----------------------------------------------------
-- Do not edit this file by hand.  Edit 
-- 'templates/ASCIIMathML.hs'
-- and run ./fillTemplates.pl Text/Pandoc/ASCIIMathML.hs
----------------------------------------------------

-- | Definitions for use of ASCIIMathML in HTML.  
-- (See <http://www1.chapman.edu/~jipsen/mathml/asciimath.html>.)
module Text.Pandoc.ASCIIMathML ( asciiMathMLScript ) where

-- | String containing ASCIIMathML javascript.
asciiMathMLScript :: String
asciiMathMLScript = "<script type=\"text/javascript\">\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n\nvar mathcolor = \"\";            // change it to \"\" (to inherit) or another color\nvar mathfontsize = \"1em\";      // change to e.g. 1.2em for larger math\nvar mathfontfamily = \"serif\";  // change to \"\" to inherit (works in IE) \n                               // or another family (e.g. \"arial\")\nvar automathrecognize = false; // writing \"amath\" on page makes this true\nvar checkForMathML = true;     // check if browser can display MathML\nvar notifyIfNoMathML = true;   // display note at top if no MathML capability\nvar alertIfNoMathML = false;   // show alert box if no MathML capability\nvar translateOnLoad = true;    // set to false to do call translators from js \nvar translateLaTeX = true;     // false to preserve $..$, $$..$$\nvar translateLaTeXformatting = true; // false to preserve \\emph,\\begin{},\\end{}\nvar translateASCIIMath = true; // false to preserve `..`\nvar translateASCIIsvg = true;  // false to preserve agraph.., \\begin{graph}..\nvar avoidinnerHTML = false;   // set true if assigning to innerHTML gives error\nvar displaystyle = true;      // puts limits above and below large operators\nvar showasciiformulaonhover = true; // helps students learn ASCIIMath\nvar decimalsign = \".\";        // change to \",\" if you like, beware of `(1,2)`!\nvar AMdelimiter1 = \"`\", AMescape1 = \"\\\\\\\\`\"; // can use other characters\nvar AMdocumentId = \"wikitext\" // PmWiki element containing math (default=body)\nvar checkforprocessasciimathinmoodle = false; // true for systems like Moodle\nvar dsvglocation = \"\"; // path to d.svg (blank if same as ASCIIMathML.js loc)\n\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n\nvar isIE = document.createElementNS==null;\nvar noMathML = false, translated = false;\n\nif (isIE) { // avoid adding MathPlayer info explicitly to each webpage\n  document.write(\"<object id=\\\"mathplayer\\\"\\\n  classid=\\\"clsid:32F66A20-7614-11D4-BD11-00104BD3F987\\\"></object>\");\n  document.write(\"<?import namespace=\\\"m\\\" implementation=\\\"#mathplayer\\\"?>\");\n}\n\n// Add a stylesheet, replacing any previous custom stylesheet (adapted from TW)\nfunction setStylesheet(s) {\n\tvar id = \"AMMLcustomStyleSheet\";\n\tvar n = document.getElementById(id);\n\tif(document.createStyleSheet) {\n\t\t// Test for IE's non-standard createStyleSheet method\n\t\tif(n)\n\t\t\tn.parentNode.removeChild(n);\n\t\t// This failed without the &nbsp;\n\t\tdocument.getElementsByTagName(\"head\")[0].insertAdjacentHTML(\"beforeEnd\",\"&nbsp;<style id='\" + id + \"'>\" + s + \"</style>\");\n\t} else {\n\t\tif(n) {\n\t\t\tn.replaceChild(document.createTextNode(s),n.firstChild);\n\t\t} else {\n\t\t\tn = document.createElement(\"style\");\n\t\t\tn.type = \"text/css\";\n\t\t\tn.id = id;\n\t\t\tn.appendChild(document.createTextNode(s));\n\t\t\tdocument.getElementsByTagName(\"head\")[0].appendChild(n);\n\t\t}\n\t}\n}\n\nsetStylesheet(\"#AMMLcloseDiv \\{font-size:0.8em; padding-top:1em; color:#014\\}\\n#AMMLwarningBox \\{position:absolute; width:100%; top:0; left:0; z-index:200; text-align:center; font-size:1em; font-weight:bold; padding:0.5em 0 0.5em 0; color:#ffc; background:#c30\\}\");\n\nfunction init(){\n\tvar msg, warnings = new Array();\n\tif (document.getElementById==null){\n\t\talert(\"This webpage requires a recent browser such as Mozilla Firefox/Netscape 7+ or Internet Explorer 6+ with MathPlayer and Adobe SVGviewer\");\n\t\treturn null;\n\t}\n\tif (checkForMathML && (msg = checkMathML())) warnings.push(msg);\n\tif (checkIfSVGavailable && (msg = checkSVG())) warnings.push(msg);\n\tif (warnings.length>0) displayWarnings(warnings);\n\tif (!noMathML) initSymbols();\n\treturn true;\n}\n\nfunction checkMathML(){\n  if (navigator.appName.slice(0,8)==\"Netscape\") \n    if (navigator.appVersion.slice(0,1)>=\"5\") noMathML = null;\n    else noMathML = true;\n  else if (navigator.appName.slice(0,9)==\"Microsoft\")\n    try {\n        var ActiveX = new ActiveXObject(\"MathPlayer.Factory.1\");\n        noMathML = null;\n    } catch (e) {\n        noMathML = true;\n    }\n  else noMathML = true;\n//noMathML = true; //uncomment to check\n  if (noMathML && notifyIfNoMathML) {\n    var msg = \"To view the ASCIIMathML notation use Internet Explorer + MathPlayer or Mozilla Firefox 2.0 or later.\";\n    if (alertIfNoMathML)\n       alert(msg);\n    else return msg;\n  }\n}\n\nfunction hideWarning(){\n\tvar body = document.getElementsByTagName(\"body\")[0];\n\tbody.removeChild(document.getElementById('AMMLwarningBox'));\n\tbody.onclick = null;\n}\n\nfunction displayWarnings(warnings) {\n  var i, frag, nd = createElementXHTML(\"div\");\n  var body = document.getElementsByTagName(\"body\")[0];\n  body.onclick=hideWarning;\n  nd.id = 'AMMLwarningBox';\n  for (i=0; i<warnings.length; i++) {\n\tfrag = createElementXHTML(\"div\");\n\tfrag.appendChild(document.createTextNode(warnings[i]));\n\tfrag.style.paddingBottom = \"1.0em\";\n\tnd.appendChild(frag);\n  }\n  nd.appendChild(createElementXHTML(\"p\"));\n  nd.appendChild(document.createTextNode(\"For instructions see the \"));\n  var an = createElementXHTML(\"a\");\n  an.appendChild(document.createTextNode(\"ASCIIMathML\"));\n  an.setAttribute(\"href\",\"http://www.chapman.edu/~jipsen/asciimath.html\");\n  nd.appendChild(an);\n  nd.appendChild(document.createTextNode(\" homepage\"));\n  an = createElementXHTML(\"div\");\n  an.id = 'AMMLcloseDiv';\n  an.appendChild(document.createTextNode('(click anywhere to close this warning)'));\n  nd.appendChild(an);\n  var body = document.getElementsByTagName(\"body\")[0];\n  body.insertBefore(nd,body.childNodes[0]);\n}\n\nfunction translate(spanclassAM) {\n  if (!translated) { // run this only once\n    translated = true;\n    var body = document.getElementsByTagName(\"body\")[0];\n    var processN = document.getElementById(AMdocumentId);\n    if (translateLaTeX) LMprocessNode((processN!=null?processN:body));\n    if (translateASCIIMath) AMprocessNode((processN!=null?processN:body), false, spanclassAM);\n  }\n}\n\nfunction createElementXHTML(t) {\n  if (isIE) return document.createElement(t);\n  else return document.createElementNS(\"http://www.w3.org/1999/xhtml\",t);\n}\n\nfunction createMmlNode(t,frag) {\n  if (isIE) var node = document.createElement(\"m:\"+t);\n  else var node = document.createElementNS(\"http://www.w3.org/1998/Math/MathML\",t);\n  if (frag) node.appendChild(frag);\n  return node;\n}\n\n// character lists for Mozilla/Netscape fonts\nvar AMcal = [0xEF35,0x212C,0xEF36,0xEF37,0x2130,0x2131,0xEF38,0x210B,0x2110,0xEF39,0xEF3A,0x2112,0x2133,0xEF3B,0xEF3C,0xEF3D,0xEF3E,0x211B,0xEF3F,0xEF40,0xEF41,0xEF42,0xEF43,0xEF44,0xEF45,0xEF46];\nvar AMfrk = [0xEF5D,0xEF5E,0x212D,0xEF5F,0xEF60,0xEF61,0xEF62,0x210C,0x2111,0xEF63,0xEF64,0xEF65,0xEF66,0xEF67,0xEF68,0xEF69,0xEF6A,0x211C,0xEF6B,0xEF6C,0xEF6D,0xEF6E,0xEF6F,0xEF70,0xEF71,0x2128];\nvar AMbbb = [0xEF8C,0xEF8D,0x2102,0xEF8E,0xEF8F,0xEF90,0xEF91,0x210D,0xEF92,0xEF93,0xEF94,0xEF95,0xEF96,0x2115,0xEF97,0x2119,0x211A,0x211D,0xEF98,0xEF99,0xEF9A,0xEF9B,0xEF9C,0xEF9D,0xEF9E,0x2124];\n\nvar CONST = 0, UNARY = 1, BINARY = 2, INFIX = 3, LEFTBRACKET = 4,\n    RIGHTBRACKET = 5, SPACE = 6, UNDEROVER = 7, DEFINITION = 8,\n    LEFTRIGHT = 9, TEXT = 10, BIG = 11, LONG = 12, STRETCHY = 13,\n    MATRIX = 14;; // token types\n\nvar AMquote = {input:\"\\\"\",   tag:\"mtext\", output:\"mbox\", tex:null, ttype:TEXT};\n\nvar AMsymbols = [\n//some greek symbols\n{input:\"alpha\",  tag:\"mi\", output:\"\\u03B1\", tex:null, ttype:CONST},\n{input:\"beta\",   tag:\"mi\", output:\"\\u03B2\", tex:null, ttype:CONST},\n{input:\"chi\",    tag:\"mi\", output:\"\\u03C7\", tex:null, ttype:CONST},\n{input:\"delta\",  tag:\"mi\", output:\"\\u03B4\", tex:null, ttype:CONST},\n{input:\"Delta\",  tag:\"mo\", output:\"\\u0394\", tex:null, ttype:CONST},\n{input:\"epsi\",   tag:\"mi\", output:\"\\u03B5\", tex:\"epsilon\", ttype:CONST},\n{input:\"varepsilon\", tag:\"mi\", output:\"\\u025B\", tex:null, ttype:CONST},\n{input:\"eta\",    tag:\"mi\", output:\"\\u03B7\", tex:null, ttype:CONST},\n{input:\"gamma\",  tag:\"mi\", output:\"\\u03B3\", tex:null, ttype:CONST},\n{input:\"Gamma\",  tag:\"mo\", output:\"\\u0393\", tex:null, ttype:CONST},\n{input:\"iota\",   tag:\"mi\", output:\"\\u03B9\", tex:null, ttype:CONST},\n{input:\"kappa\",  tag:\"mi\", output:\"\\u03BA\", tex:null, ttype:CONST},\n{input:\"lambda\", tag:\"mi\", output:\"\\u03BB\", tex:null, ttype:CONST},\n{input:\"Lambda\", tag:\"mo\", output:\"\\u039B\", tex:null, ttype:CONST},\n{input:\"mu\",     tag:\"mi\", output:\"\\u03BC\", tex:null, ttype:CONST},\n{input:\"nu\",     tag:\"mi\", output:\"\\u03BD\", tex:null, ttype:CONST},\n{input:\"omega\",  tag:\"mi\", output:\"\\u03C9\", tex:null, ttype:CONST},\n{input:\"Omega\",  tag:\"mo\", output:\"\\u03A9\", tex:null, ttype:CONST},\n{input:\"phi\",    tag:\"mi\", output:\"\\u03C6\", tex:null, ttype:CONST},\n{input:\"varphi\", tag:\"mi\", output:\"\\u03D5\", tex:null, ttype:CONST},\n{input:\"Phi\",    tag:\"mo\", output:\"\\u03A6\", tex:null, ttype:CONST},\n{input:\"pi\",     tag:\"mi\", output:\"\\u03C0\", tex:null, ttype:CONST},\n{input:\"Pi\",     tag:\"mo\", output:\"\\u03A0\", tex:null, ttype:CONST},\n{input:\"psi\",    tag:\"mi\", output:\"\\u03C8\", tex:null, ttype:CONST},\n{input:\"Psi\",    tag:\"mi\", output:\"\\u03A8\", tex:null, ttype:CONST},\n{input:\"rho\",    tag:\"mi\", output:\"\\u03C1\", tex:null, ttype:CONST},\n{input:\"sigma\",  tag:\"mi\", output:\"\\u03C3\", tex:null, ttype:CONST},\n{input:\"Sigma\",  tag:\"mo\", output:\"\\u03A3\", tex:null, ttype:CONST},\n{input:\"tau\",    tag:\"mi\", output:\"\\u03C4\", tex:null, ttype:CONST},\n{input:\"theta\",  tag:\"mi\", output:\"\\u03B8\", tex:null, ttype:CONST},\n{input:\"vartheta\", tag:\"mi\", output:\"\\u03D1\", tex:null, ttype:CONST},\n{input:\"Theta\",  tag:\"mo\", output:\"\\u0398\", tex:null, ttype:CONST},\n{input:\"upsilon\", tag:\"mi\", output:\"\\u03C5\", tex:null, ttype:CONST},\n{input:\"xi\",     tag:\"mi\", output:\"\\u03BE\", tex:null, ttype:CONST},\n{input:\"Xi\",     tag:\"mo\", output:\"\\u039E\", tex:null, ttype:CONST},\n{input:\"zeta\",   tag:\"mi\", output:\"\\u03B6\", tex:null, ttype:CONST},\n\n//binary operation symbols\n//{input:\"-\",  tag:\"mo\", output:\"\\u0096\", tex:null, ttype:CONST},\n{input:\"*\",  tag:\"mo\", output:\"\\u22C5\", tex:\"cdot\", ttype:CONST},\n{input:\"**\", tag:\"mo\", output:\"\\u22C6\", tex:\"star\", ttype:CONST},\n{input:\"//\", tag:\"mo\", output:\"/\",      tex:null, ttype:CONST},\n{input:\"\\\\\\\\\", tag:\"mo\", output:\"\\\\\",   tex:\"backslash\", ttype:CONST},\n{input:\"setminus\", tag:\"mo\", output:\"\\\\\", tex:null, ttype:CONST},\n{input:\"xx\", tag:\"mo\", output:\"\\u00D7\", tex:\"times\", ttype:CONST},\n{input:\"-:\", tag:\"mo\", output:\"\\u00F7\", tex:\"divide\", ttype:CONST},\n{input:\"@\",  tag:\"mo\", output:\"\\u2218\", tex:\"circ\", ttype:CONST},\n{input:\"o+\", tag:\"mo\", output:\"\\u2295\", tex:\"oplus\", ttype:CONST},\n{input:\"ox\", tag:\"mo\", output:\"\\u2297\", tex:\"otimes\", ttype:CONST},\n{input:\"o.\", tag:\"mo\", output:\"\\u2299\", tex:\"odot\", ttype:CONST},\n{input:\"sum\", tag:\"mo\", output:\"\\u2211\", tex:null, ttype:UNDEROVER},\n{input:\"prod\", tag:\"mo\", output:\"\\u220F\", tex:null, ttype:UNDEROVER},\n{input:\"^^\",  tag:\"mo\", output:\"\\u2227\", tex:\"wedge\", ttype:CONST},\n{input:\"^^^\", tag:\"mo\", output:\"\\u22C0\", tex:\"bigwedge\", ttype:UNDEROVER},\n{input:\"vv\",  tag:\"mo\", output:\"\\u2228\", tex:\"vee\", ttype:CONST},\n{input:\"vvv\", tag:\"mo\", output:\"\\u22C1\", tex:\"bigvee\", ttype:UNDEROVER},\n{input:\"nn\",  tag:\"mo\", output:\"\\u2229\", tex:\"cap\", ttype:CONST},\n{input:\"nnn\", tag:\"mo\", output:\"\\u22C2\", tex:\"bigcap\", ttype:UNDEROVER},\n{input:\"uu\",  tag:\"mo\", output:\"\\u222A\", tex:\"cup\", ttype:CONST},\n{input:\"uuu\", tag:\"mo\", output:\"\\u22C3\", tex:\"bigcup\", ttype:UNDEROVER},\n\n//binary relation symbols\n{input:\"!=\",  tag:\"mo\", output:\"\\u2260\", tex:\"ne\", ttype:CONST},\n{input:\":=\",  tag:\"mo\", output:\":=\",     tex:null, ttype:CONST},\n{input:\"lt\",  tag:\"mo\", output:\"<\",      tex:null, ttype:CONST},\n{input:\"<=\",  tag:\"mo\", output:\"\\u2264\", tex:\"le\", ttype:CONST},\n{input:\"lt=\", tag:\"mo\", output:\"\\u2264\", tex:\"leq\", ttype:CONST},\n{input:\">=\",  tag:\"mo\", output:\"\\u2265\", tex:\"ge\", ttype:CONST},\n{input:\"geq\", tag:\"mo\", output:\"\\u2265\", tex:null, ttype:CONST},\n{input:\"-<\",  tag:\"mo\", output:\"\\u227A\", tex:\"prec\", ttype:CONST},\n{input:\"-lt\", tag:\"mo\", output:\"\\u227A\", tex:null, ttype:CONST},\n{input:\">-\",  tag:\"mo\", output:\"\\u227B\", tex:\"succ\", ttype:CONST},\n{input:\"-<=\", tag:\"mo\", output:\"\\u2AAF\", tex:\"preceq\", ttype:CONST},\n{input:\">-=\", tag:\"mo\", output:\"\\u2AB0\", tex:\"succeq\", ttype:CONST},\n{input:\"in\",  tag:\"mo\", output:\"\\u2208\", tex:null, ttype:CONST},\n{input:\"!in\", tag:\"mo\", output:\"\\u2209\", tex:\"notin\", ttype:CONST},\n{input:\"sub\", tag:\"mo\", output:\"\\u2282\", tex:\"subset\", ttype:CONST},\n{input:\"sup\", tag:\"mo\", output:\"\\u2283\", tex:\"supset\", ttype:CONST},\n{input:\"sube\", tag:\"mo\", output:\"\\u2286\", tex:\"subseteq\", ttype:CONST},\n{input:\"supe\", tag:\"mo\", output:\"\\u2287\", tex:\"supseteq\", ttype:CONST},\n{input:\"-=\",  tag:\"mo\", output:\"\\u2261\", tex:\"equiv\", ttype:CONST},\n{input:\"~=\",  tag:\"mo\", output:\"\\u2245\", tex:\"cong\", ttype:CONST},\n{input:\"~~\",  tag:\"mo\", output:\"\\u2248\", tex:\"approx\", ttype:CONST},\n{input:\"prop\", tag:\"mo\", output:\"\\u221D\", tex:\"propto\", ttype:CONST},\n\n//logical symbols\n{input:\"and\", tag:\"mtext\", output:\"and\", tex:null, ttype:SPACE},\n{input:\"or\",  tag:\"mtext\", output:\"or\",  tex:null, ttype:SPACE},\n{input:\"not\", tag:\"mo\", output:\"\\u00AC\", tex:\"neg\", ttype:CONST},\n{input:\"=>\",  tag:\"mo\", output:\"\\u21D2\", tex:\"implies\", ttype:CONST},\n{input:\"if\",  tag:\"mo\", output:\"if\",     tex:null, ttype:SPACE},\n{input:\"<=>\", tag:\"mo\", output:\"\\u21D4\", tex:\"iff\", ttype:CONST},\n{input:\"AA\",  tag:\"mo\", output:\"\\u2200\", tex:\"forall\", ttype:CONST},\n{input:\"EE\",  tag:\"mo\", output:\"\\u2203\", tex:\"exists\", ttype:CONST},\n{input:\"_|_\", tag:\"mo\", output:\"\\u22A5\", tex:\"bot\", ttype:CONST},\n{input:\"TT\",  tag:\"mo\", output:\"\\u22A4\", tex:\"top\", ttype:CONST},\n{input:\"|--\",  tag:\"mo\", output:\"\\u22A2\", tex:\"vdash\", ttype:CONST},\n{input:\"|==\",  tag:\"mo\", output:\"\\u22A8\", tex:\"models\", ttype:CONST},\n\n//grouping brackets\n{input:\"(\", tag:\"mo\", output:\"(\", tex:null, ttype:LEFTBRACKET},\n{input:\")\", tag:\"mo\", output:\")\", tex:null, ttype:RIGHTBRACKET},\n{input:\"[\", tag:\"mo\", output:\"[\", tex:null, ttype:LEFTBRACKET},\n{input:\"]\", tag:\"mo\", output:\"]\", tex:null, ttype:RIGHTBRACKET},\n{input:\"{\", tag:\"mo\", output:\"{\", tex:null, ttype:LEFTBRACKET},\n{input:\"}\", tag:\"mo\", output:\"}\", tex:null, ttype:RIGHTBRACKET},\n{input:\"|\", tag:\"mo\", output:\"|\", tex:null, ttype:LEFTRIGHT},\n//{input:\"||\", tag:\"mo\", output:\"||\", tex:null, ttype:LEFTRIGHT},\n{input:\"(:\", tag:\"mo\", output:\"\\u2329\", tex:\"langle\", ttype:LEFTBRACKET},\n{input:\":)\", tag:\"mo\", output:\"\\u232A\", tex:\"rangle\", ttype:RIGHTBRACKET},\n{input:\"<<\", tag:\"mo\", output:\"\\u2329\", tex:null, ttype:LEFTBRACKET},\n{input:\">>\", tag:\"mo\", output:\"\\u232A\", tex:null, ttype:RIGHTBRACKET},\n{input:\"{:\", tag:\"mo\", output:\"{:\", tex:null, ttype:LEFTBRACKET, invisible:true},\n{input:\":}\", tag:\"mo\", output:\":}\", tex:null, ttype:RIGHTBRACKET, invisible:true},\n\n//miscellaneous symbols\n{input:\"int\",  tag:\"mo\", output:\"\\u222B\", tex:null, ttype:CONST},\n{input:\"dx\",   tag:\"mi\", output:\"{:d x:}\", tex:null, ttype:DEFINITION},\n{input:\"dy\",   tag:\"mi\", output:\"{:d y:}\", tex:null, ttype:DEFINITION},\n{input:\"dz\",   tag:\"mi\", output:\"{:d z:}\", tex:null, ttype:DEFINITION},\n{input:\"dt\",   tag:\"mi\", output:\"{:d t:}\", tex:null, ttype:DEFINITION},\n{input:\"oint\", tag:\"mo\", output:\"\\u222E\", tex:null, ttype:CONST},\n{input:\"del\",  tag:\"mo\", output:\"\\u2202\", tex:\"partial\", ttype:CONST},\n{input:\"grad\", tag:\"mo\", output:\"\\u2207\", tex:\"nabla\", ttype:CONST},\n{input:\"+-\",   tag:\"mo\", output:\"\\u00B1\", tex:\"pm\", ttype:CONST},\n{input:\"O/\",   tag:\"mo\", output:\"\\u2205\", tex:\"emptyset\", ttype:CONST},\n{input:\"oo\",   tag:\"mo\", output:\"\\u221E\", tex:\"infty\", ttype:CONST},\n{input:\"aleph\", tag:\"mo\", output:\"\\u2135\", tex:null, ttype:CONST},\n{input:\"...\",  tag:\"mo\", output:\"...\",    tex:\"ldots\", ttype:CONST},\n{input:\":.\",  tag:\"mo\", output:\"\\u2234\",  tex:\"therefore\", ttype:CONST},\n{input:\"/_\",  tag:\"mo\", output:\"\\u2220\",  tex:\"angle\", ttype:CONST},\n{input:\"\\\\ \",  tag:\"mo\", output:\"\\u00A0\", tex:null, ttype:CONST},\n{input:\"quad\", tag:\"mo\", output:\"\\u00A0\\u00A0\", tex:null, ttype:CONST},\n{input:\"qquad\", tag:\"mo\", output:\"\\u00A0\\u00A0\\u00A0\\u00A0\", tex:null, ttype:CONST},\n{input:\"cdots\", tag:\"mo\", output:\"\\u22EF\", tex:null, ttype:CONST},\n{input:\"vdots\", tag:\"mo\", output:\"\\u22EE\", tex:null, ttype:CONST},\n{input:\"ddots\", tag:\"mo\", output:\"\\u22F1\", tex:null, ttype:CONST},\n{input:\"diamond\", tag:\"mo\", output:\"\\u22C4\", tex:null, ttype:CONST},\n{input:\"square\", tag:\"mo\", output:\"\\u25A1\", tex:null, ttype:CONST},\n{input:\"|__\", tag:\"mo\", output:\"\\u230A\",  tex:\"lfloor\", ttype:CONST},\n{input:\"__|\", tag:\"mo\", output:\"\\u230B\",  tex:\"rfloor\", ttype:CONST},\n{input:\"|~\", tag:\"mo\", output:\"\\u2308\",  tex:\"lceiling\", ttype:CONST},\n{input:\"~|\", tag:\"mo\", output:\"\\u2309\",  tex:\"rceiling\", ttype:CONST},\n{input:\"CC\",  tag:\"mo\", output:\"\\u2102\", tex:null, ttype:CONST},\n{input:\"NN\",  tag:\"mo\", output:\"\\u2115\", tex:null, ttype:CONST},\n{input:\"QQ\",  tag:\"mo\", output:\"\\u211A\", tex:null, ttype:CONST},\n{input:\"RR\",  tag:\"mo\", output:\"\\u211D\", tex:null, ttype:CONST},\n{input:\"ZZ\",  tag:\"mo\", output:\"\\u2124\", tex:null, ttype:CONST},\n{input:\"f\",   tag:\"mi\", output:\"f\",      tex:null, ttype:UNARY, func:true},\n{input:\"g\",   tag:\"mi\", output:\"g\",      tex:null, ttype:UNARY, func:true},\n\n//standard functions\n{input:\"lim\",  tag:\"mo\", output:\"lim\", tex:null, ttype:UNDEROVER},\n{input:\"Lim\",  tag:\"mo\", output:\"Lim\", tex:null, ttype:UNDEROVER},\n{input:\"sin\",  tag:\"mo\", output:\"sin\", tex:null, ttype:UNARY, func:true},\n{input:\"cos\",  tag:\"mo\", output:\"cos\", tex:null, ttype:UNARY, func:true},\n{input:\"tan\",  tag:\"mo\", output:\"tan\", tex:null, ttype:UNARY, func:true},\n{input:\"sinh\", tag:\"mo\", output:\"sinh\", tex:null, ttype:UNARY, func:true},\n{input:\"cosh\", tag:\"mo\", output:\"cosh\", tex:null, ttype:UNARY, func:true},\n{input:\"tanh\", tag:\"mo\", output:\"tanh\", tex:null, ttype:UNARY, func:true},\n{input:\"cot\",  tag:\"mo\", output:\"cot\", tex:null, ttype:UNARY, func:true},\n{input:\"sec\",  tag:\"mo\", output:\"sec\", tex:null, ttype:UNARY, func:true},\n{input:\"csc\",  tag:\"mo\", output:\"csc\", tex:null, ttype:UNARY, func:true},\n{input:\"log\",  tag:\"mo\", output:\"log\", tex:null, ttype:UNARY, func:true},\n{input:\"ln\",   tag:\"mo\", output:\"ln\",  tex:null, ttype:UNARY, func:true},\n{input:\"det\",  tag:\"mo\", output:\"det\", tex:null, ttype:UNARY, func:true},\n{input:\"dim\",  tag:\"mo\", output:\"dim\", tex:null, ttype:CONST},\n{input:\"mod\",  tag:\"mo\", output:\"mod\", tex:null, ttype:CONST},\n{input:\"gcd\",  tag:\"mo\", output:\"gcd\", tex:null, ttype:UNARY, func:true},\n{input:\"lcm\",  tag:\"mo\", output:\"lcm\", tex:null, ttype:UNARY, func:true},\n{input:\"lub\",  tag:\"mo\", output:\"lub\", tex:null, ttype:CONST},\n{input:\"glb\",  tag:\"mo\", output:\"glb\", tex:null, ttype:CONST},\n{input:\"min\",  tag:\"mo\", output:\"min\", tex:null, ttype:UNDEROVER},\n{input:\"max\",  tag:\"mo\", output:\"max\", tex:null, ttype:UNDEROVER},\n\n//arrows\n{input:\"uarr\", tag:\"mo\", output:\"\\u2191\", tex:\"uparrow\", ttype:CONST},\n{input:\"darr\", tag:\"mo\", output:\"\\u2193\", tex:\"downarrow\", ttype:CONST},\n{input:\"rarr\", tag:\"mo\", output:\"\\u2192\", tex:\"rightarrow\", ttype:CONST},\n{input:\"->\",   tag:\"mo\", output:\"\\u2192\", tex:\"to\", ttype:CONST},\n{input:\">->\",   tag:\"mo\", output:\"\\u21A3\", tex:\"rightarrowtail\", ttype:CONST},\n{input:\"->>\",   tag:\"mo\", output:\"\\u21A0\", tex:\"twoheadrightarrow\", ttype:CONST},\n{input:\">->>\",   tag:\"mo\", output:\"\\u2916\", tex:\"twoheadrightarrowtail\", ttype:CONST},\n{input:\"|->\",  tag:\"mo\", output:\"\\u21A6\", tex:\"mapsto\", ttype:CONST},\n{input:\"larr\", tag:\"mo\", output:\"\\u2190\", tex:\"leftarrow\", ttype:CONST},\n{input:\"harr\", tag:\"mo\", output:\"\\u2194\", tex:\"leftrightarrow\", ttype:CONST},\n{input:\"rArr\", tag:\"mo\", output:\"\\u21D2\", tex:\"Rightarrow\", ttype:CONST},\n{input:\"lArr\", tag:\"mo\", output:\"\\u21D0\", tex:\"Leftarrow\", ttype:CONST},\n{input:\"hArr\", tag:\"mo\", output:\"\\u21D4\", tex:\"Leftrightarrow\", ttype:CONST},\n//commands with argument\n{input:\"sqrt\", tag:\"msqrt\", output:\"sqrt\", tex:null, ttype:UNARY},\n{input:\"root\", tag:\"mroot\", output:\"root\", tex:null, ttype:BINARY},\n{input:\"frac\", tag:\"mfrac\", output:\"/\",    tex:null, ttype:BINARY},\n{input:\"/\",    tag:\"mfrac\", output:\"/\",    tex:null, ttype:INFIX},\n{input:\"stackrel\", tag:\"mover\", output:\"stackrel\", tex:null, ttype:BINARY},\n{input:\"_\",    tag:\"msub\",  output:\"_\",    tex:null, ttype:INFIX},\n{input:\"^\",    tag:\"msup\",  output:\"^\",    tex:null, ttype:INFIX},\n{input:\"hat\", tag:\"mover\", output:\"\\u005E\", tex:null, ttype:UNARY, acc:true},\n{input:\"bar\", tag:\"mover\", output:\"\\u00AF\", tex:\"overline\", ttype:UNARY, acc:true},\n{input:\"vec\", tag:\"mover\", output:\"\\u2192\", tex:null, ttype:UNARY, acc:true},\n{input:\"dot\", tag:\"mover\", output:\".\",      tex:null, ttype:UNARY, acc:true},\n{input:\"ddot\", tag:\"mover\", output:\"..\",    tex:null, ttype:UNARY, acc:true},\n{input:\"ul\", tag:\"munder\", output:\"\\u0332\", tex:\"underline\", ttype:UNARY, acc:true},\n{input:\"text\", tag:\"mtext\", output:\"text\", tex:null, ttype:TEXT},\n{input:\"mbox\", tag:\"mtext\", output:\"mbox\", tex:null, ttype:TEXT},\nAMquote,\n{input:\"bb\", tag:\"mstyle\", atname:\"fontweight\", atval:\"bold\", output:\"bb\", tex:null, ttype:UNARY},\n{input:\"mathbf\", tag:\"mstyle\", atname:\"fontweight\", atval:\"bold\", output:\"mathbf\", tex:null, ttype:UNARY},\n{input:\"sf\", tag:\"mstyle\", atname:\"fontfamily\", atval:\"sans-serif\", output:\"sf\", tex:null, ttype:UNARY},\n{input:\"mathsf\", tag:\"mstyle\", atname:\"fontfamily\", atval:\"sans-serif\", output:\"mathsf\", tex:null, ttype:UNARY},\n{input:\"bbb\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"double-struck\", output:\"bbb\", tex:null, ttype:UNARY, codes:AMbbb},\n{input:\"mathbb\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"double-struck\", output:\"mathbb\", tex:null, ttype:UNARY, codes:AMbbb},\n{input:\"cc\",  tag:\"mstyle\", atname:\"mathvariant\", atval:\"script\", output:\"cc\", tex:null, ttype:UNARY, codes:AMcal},\n{input:\"mathcal\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"script\", output:\"mathcal\", tex:null, ttype:UNARY, codes:AMcal},\n{input:\"tt\",  tag:\"mstyle\", atname:\"fontfamily\", atval:\"monospace\", output:\"tt\", tex:null, ttype:UNARY},\n{input:\"mathtt\", tag:\"mstyle\", atname:\"fontfamily\", atval:\"monospace\", output:\"mathtt\", tex:null, ttype:UNARY},\n{input:\"fr\",  tag:\"mstyle\", atname:\"mathvariant\", atval:\"fraktur\", output:\"fr\", tex:null, ttype:UNARY, codes:AMfrk},\n{input:\"mathfrak\",  tag:\"mstyle\", atname:\"mathvariant\", atval:\"fraktur\", output:\"mathfrak\", tex:null, ttype:UNARY, codes:AMfrk}\n];\n\nfunction compareNames(s1,s2) {\n  if (s1.input > s2.input) return 1\n  else return -1;\n}\n\nvar AMnames = []; //list of input symbols\n\nfunction initSymbols() {\n  var texsymbols = [], i;\n  for (i=0; i<AMsymbols.length; i++)\n    if (AMsymbols[i].tex) \n      texsymbols[texsymbols.length] = {input:AMsymbols[i].tex, \n        tag:AMsymbols[i].tag, output:AMsymbols[i].output, ttype:AMsymbols[i].ttype};\n  AMsymbols = AMsymbols.concat(texsymbols);\n  refreshSymbols();\n}\n\nfunction refreshSymbols(){\n  var i;\n  AMsymbols.sort(compareNames);\n  for (i=0; i<AMsymbols.length; i++) AMnames[i] = AMsymbols[i].input;\n  LMsymbols.sort(compareNames);\n  for (i=0; i<LMsymbols.length; i++) LMnames[i] = LMsymbols[i].input;\n}\n\nfunction define(oldstr,newstr) {\n  if(oldstr.substr(0,1)==\"\\\\\")\n    LMsymbols = LMsymbols.concat([{input:oldstr, tag:\"mo\", output:newstr,\n                                 ttype:DEFINITION}]);\n  else\n    AMsymbols = AMsymbols.concat([{input:oldstr, tag:\"mo\", output:newstr, \n                                 tex:null, ttype:DEFINITION}]);\n  refreshSymbols(); // this may be a problem if many symbols are defined!\n}\n\nfunction AMremoveCharsAndBlanks(str,n) {\n//remove n characters and any following blanks\n  var st;\n  if (str.charAt(n)==\"\\\\\" && str.charAt(n+1)!=\"\\\\\" && str.charAt(n+1)!=\" \") \n    st = str.slice(n+1);\n  else st = str.slice(n);\n  for (var i=0; i<st.length && st.charCodeAt(i)<=32; i=i+1);\n  return st.slice(i);\n}\n\nfunction position(arr, str, n) { \n// return position >=n where str appears or would be inserted\n// assumes arr is sorted\n  if (n==0) {\n    var h,m;\n    n = -1;\n    h = arr.length;\n    while (n+1<h) {\n      m = (n+h) >> 1;\n      if (arr[m]<str) n = m; else h = m;\n    }\n    return h;\n  } else\n    for (var i=n; i<arr.length && arr[i]<str; i++);\n  return i; // i=arr.length || arr[i]>=str\n}\n\nfunction AMgetSymbol(str) {\n//return maximal initial substring of str that appears in names\n//return null if there is none\n  var k = 0; //new pos\n  var j = 0; //old pos\n  var mk; //match pos\n  var st;\n  var tagst;\n  var match = \"\";\n  var more = true;\n  for (var i=1; i<=str.length && more; i++) {\n    st = str.slice(0,i); //initial substring of length i\n    j = k;\n    k = position(AMnames, st, j);\n    if (k<AMnames.length && str.slice(0,AMnames[k].length)==AMnames[k]){\n      match = AMnames[k];\n      mk = k;\n      i = match.length;\n    }\n    more = k<AMnames.length && str.slice(0,AMnames[k].length)>=AMnames[k];\n  }\n  AMpreviousSymbol=AMcurrentSymbol;\n  if (match!=\"\"){\n    AMcurrentSymbol=AMsymbols[mk].ttype;\n    return AMsymbols[mk]; \n  }\n// if str[0] is a digit or - return maxsubstring of digits.digits\n  AMcurrentSymbol=CONST;\n  k = 1;\n  st = str.slice(0,1);\n  var integ = true;\n  while (\"0\"<=st && st<=\"9\" && k<=str.length) {\n    st = str.slice(k,k+1);\n    k++;\n  }\n  if (st == decimalsign) {\n    st = str.slice(k,k+1);\n    if (\"0\"<=st && st<=\"9\") {\n      integ = false;\n      k++;\n      while (\"0\"<=st && st<=\"9\" && k<=str.length) {\n        st = str.slice(k,k+1);\n        k++;\n      }\n    }\n  }\n  if ((integ && k>1) || k>2) {\n    st = str.slice(0,k-1);\n    tagst = \"mn\";\n  } else {\n    k = 2;\n    st = str.slice(0,1); //take 1 character\n    tagst = ((\"A\">st || st>\"Z\") && (\"a\">st || st>\"z\")?\"mo\":\"mi\");\n  }\n  if (st==\"-\" && AMpreviousSymbol==INFIX) {\n    AMcurrentSymbol = INFIX;  //trick \"/\" into recognizing \"-\" on second parse\n    return {input:st, tag:tagst, output:st, ttype:UNARY, func:true};\n  }\n  return {input:st, tag:tagst, output:st, ttype:CONST};\n}\n\nfunction AMremoveBrackets(node) {\n  var st;\n  if (node.nodeName==\"mrow\") {\n    st = node.firstChild.firstChild.nodeValue;\n    if (st==\"(\" || st==\"[\" || st==\"{\") node.removeChild(node.firstChild);\n  }\n  if (node.nodeName==\"mrow\") {\n    st = node.lastChild.firstChild.nodeValue;\n    if (st==\")\" || st==\"]\" || st==\"}\") node.removeChild(node.lastChild);\n  }\n}\n\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n\nvar AMnestingDepth,AMpreviousSymbol,AMcurrentSymbol;\n\nfunction AMparseSexpr(str) { //parses str and returns [node,tailstr]\n  var symbol, node, result, i, st,// rightvert = false,\n    newFrag = document.createDocumentFragment();\n  str = AMremoveCharsAndBlanks(str,0);\n  symbol = AMgetSymbol(str);             //either a token or a bracket or empty\n  if (symbol == null || symbol.ttype == RIGHTBRACKET && AMnestingDepth > 0) {\n    return [null,str];\n  }\n  if (symbol.ttype == DEFINITION) {\n    str = symbol.output+AMremoveCharsAndBlanks(str,symbol.input.length); \n    symbol = AMgetSymbol(str);\n  }\n  switch (symbol.ttype) {  case UNDEROVER:\n  case CONST:\n    str = AMremoveCharsAndBlanks(str,symbol.input.length); \n    return [createMmlNode(symbol.tag,        //its a constant\n                             document.createTextNode(symbol.output)),str];\n  case LEFTBRACKET:   //read (expr+)\n    AMnestingDepth++;\n    str = AMremoveCharsAndBlanks(str,symbol.input.length); \n    result = AMparseExpr(str,true);\n    AMnestingDepth--;\n    if (typeof symbol.invisible == \"boolean\" && symbol.invisible) \n      node = createMmlNode(\"mrow\",result[0]);\n    else {\n      node = createMmlNode(\"mo\",document.createTextNode(symbol.output));\n      node = createMmlNode(\"mrow\",node);\n      node.appendChild(result[0]);\n    }\n    return [node,result[1]];\n  case TEXT:\n      if (symbol!=AMquote) str = AMremoveCharsAndBlanks(str,symbol.input.length);\n      if (str.charAt(0)==\"{\") i=str.indexOf(\"}\");\n      else if (str.charAt(0)==\"(\") i=str.indexOf(\")\");\n      else if (str.charAt(0)==\"[\") i=str.indexOf(\"]\");\n      else if (symbol==AMquote) i=str.slice(1).indexOf(\"\\\"\")+1;\n      else i = 0;\n      if (i==-1) i = str.length;\n      st = str.slice(1,i);\n      if (st.charAt(0) == \" \") {\n        node = createMmlNode(\"mspace\");\n        node.setAttribute(\"width\",\"1ex\");\n        newFrag.appendChild(node);\n      }\n      newFrag.appendChild(\n        createMmlNode(symbol.tag,document.createTextNode(st)));\n      if (st.charAt(st.length-1) == \" \") {\n        node = createMmlNode(\"mspace\");\n        node.setAttribute(\"width\",\"1ex\");\n        newFrag.appendChild(node);\n      }\n      str = AMremoveCharsAndBlanks(str,i+1);\n      return [createMmlNode(\"mrow\",newFrag),str];\n  case UNARY:\n      str = AMremoveCharsAndBlanks(str,symbol.input.length); \n      result = AMparseSexpr(str);\n      if (result[0]==null) return [createMmlNode(symbol.tag,\n                             document.createTextNode(symbol.output)),str];\n      if (typeof symbol.func == \"boolean\" && symbol.func) { // functions hack\n        st = str.charAt(0);\n        if (st==\"^\" || st==\"_\" || st==\"/\" || st==\"|\" || st==\",\") {\n          return [createMmlNode(symbol.tag,\n                    document.createTextNode(symbol.output)),str];\n        } else {\n          node = createMmlNode(\"mrow\",\n           createMmlNode(symbol.tag,document.createTextNode(symbol.output)));\n          node.appendChild(result[0]);\n          return [node,result[1]];\n        }\n      }\n      AMremoveBrackets(result[0]);\n      if (symbol.input == \"sqrt\") {           // sqrt\n        return [createMmlNode(symbol.tag,result[0]),result[1]];\n      } else if (typeof symbol.acc == \"boolean\" && symbol.acc) {   // accent\n        node = createMmlNode(symbol.tag,result[0]);\n        node.appendChild(createMmlNode(\"mo\",document.createTextNode(symbol.output)));\n        return [node,result[1]];\n      } else {                        // font change command\n        if (!isIE && typeof symbol.codes != \"undefined\") {\n          for (i=0; i<result[0].childNodes.length; i++)\n            if (result[0].childNodes[i].nodeName==\"mi\" || result[0].nodeName==\"mi\") {\n              st = (result[0].nodeName==\"mi\"?result[0].firstChild.nodeValue:\n                              result[0].childNodes[i].firstChild.nodeValue);\n              var newst = [];\n              for (var j=0; j<st.length; j++)\n                if (st.charCodeAt(j)>64 && st.charCodeAt(j)<91) newst = newst +\n                  String.fromCharCode(symbol.codes[st.charCodeAt(j)-65]);\n                else newst = newst + st.charAt(j);\n              if (result[0].nodeName==\"mi\")\n                result[0]=createMmlNode(\"mo\").\n                          appendChild(document.createTextNode(newst));\n              else result[0].replaceChild(createMmlNode(\"mo\").\n                               appendChild(document.createTextNode(newst)),\n                                           result[0].childNodes[i]);\n            }\n        }\n        node = createMmlNode(symbol.tag,result[0]);\n        node.setAttribute(symbol.atname,symbol.atval);\n        return [node,result[1]];\n      }\n  case BINARY:\n    str = AMremoveCharsAndBlanks(str,symbol.input.length); \n    result = AMparseSexpr(str);\n    if (result[0]==null) return [createMmlNode(\"mo\",\n                           document.createTextNode(symbol.input)),str];\n    AMremoveBrackets(result[0]);\n    var result2 = AMparseSexpr(result[1]);\n    if (result2[0]==null) return [createMmlNode(\"mo\",\n                           document.createTextNode(symbol.input)),str];\n    AMremoveBrackets(result2[0]);\n    if (symbol.input==\"root\" || symbol.input==\"stackrel\") \n      newFrag.appendChild(result2[0]);\n    newFrag.appendChild(result[0]);\n    if (symbol.input==\"frac\") newFrag.appendChild(result2[0]);\n    return [createMmlNode(symbol.tag,newFrag),result2[1]];\n  case INFIX:\n    str = AMremoveCharsAndBlanks(str,symbol.input.length); \n    return [createMmlNode(\"mo\",document.createTextNode(symbol.output)),str];\n  case SPACE:\n    str = AMremoveCharsAndBlanks(str,symbol.input.length); \n    node = createMmlNode(\"mspace\");\n    node.setAttribute(\"width\",\"1ex\");\n    newFrag.appendChild(node);\n    newFrag.appendChild(\n      createMmlNode(symbol.tag,document.createTextNode(symbol.output)));\n    node = createMmlNode(\"mspace\");\n    node.setAttribute(\"width\",\"1ex\");\n    newFrag.appendChild(node);\n    return [createMmlNode(\"mrow\",newFrag),str];\n  case LEFTRIGHT:\n//    if (rightvert) return [null,str]; else rightvert = true;\n    AMnestingDepth++;\n    str = AMremoveCharsAndBlanks(str,symbol.input.length); \n    result = AMparseExpr(str,false);\n    AMnestingDepth--;\n    var st = \"\";\n    if (result[0].lastChild!=null)\n      st = result[0].lastChild.firstChild.nodeValue;\n    if (st == \"|\") { // its an absolute value subterm\n      node = createMmlNode(\"mo\",document.createTextNode(symbol.output));\n      node = createMmlNode(\"mrow\",node);\n      node.appendChild(result[0]);\n      return [node,result[1]];\n    } else { // the \"|\" is a \\mid so use unicode 2223 (divides) for spacing\n      node = createMmlNode(\"mo\",document.createTextNode(\"\\u2223\"));\n      node = createMmlNode(\"mrow\",node);\n      return [node,str];\n    }\n  default:\n//alert(\"default\");\n    str = AMremoveCharsAndBlanks(str,symbol.input.length); \n    return [createMmlNode(symbol.tag,        //its a constant\n                             document.createTextNode(symbol.output)),str];\n  }\n}\n\nfunction AMparseIexpr(str) {\n  var symbol, sym1, sym2, node, result, underover;\n  str = AMremoveCharsAndBlanks(str,0);\n  sym1 = AMgetSymbol(str);\n  result = AMparseSexpr(str);\n  node = result[0];\n  str = result[1];\n  symbol = AMgetSymbol(str);\n  if (symbol.ttype == INFIX && symbol.input != \"/\") {\n    str = AMremoveCharsAndBlanks(str,symbol.input.length);\n//    if (symbol.input == \"/\") result = AMparseIexpr(str); else ...\n    result = AMparseSexpr(str);\n    if (result[0] == null) // show box in place of missing argument\n      result[0] = createMmlNode(\"mo\",document.createTextNode(\"\\u25A1\"));\n    else AMremoveBrackets(result[0]);\n    str = result[1];\n//    if (symbol.input == \"/\") AMremoveBrackets(node);\n    if (symbol.input == \"_\") {\n      sym2 = AMgetSymbol(str);\n      underover = (sym1.ttype == UNDEROVER);\n      if (sym2.input == \"^\") {\n        str = AMremoveCharsAndBlanks(str,sym2.input.length);\n        var res2 = AMparseSexpr(str);\n        AMremoveBrackets(res2[0]);\n        str = res2[1];\n        node = createMmlNode((underover?\"munderover\":\"msubsup\"),node);\n        node.appendChild(result[0]);\n        node.appendChild(res2[0]);\n        node = createMmlNode(\"mrow\",node); // so sum does not stretch\n      } else {\n        node = createMmlNode((underover?\"munder\":\"msub\"),node);\n        node.appendChild(result[0]);\n      }\n    } else {\n      node = createMmlNode(symbol.tag,node);\n      node.appendChild(result[0]);\n    }\n  }\n  return [node,str];\n}\n\nfunction AMparseExpr(str,rightbracket) {\n  var symbol, node, result, i, nodeList = [],\n  newFrag = document.createDocumentFragment();\n  do {\n    str = AMremoveCharsAndBlanks(str,0);\n    result = AMparseIexpr(str);\n    node = result[0];\n    str = result[1];\n    symbol = AMgetSymbol(str);\n    if (symbol.ttype == INFIX && symbol.input == \"/\") {\n      str = AMremoveCharsAndBlanks(str,symbol.input.length);\n      result = AMparseIexpr(str);\n      if (result[0] == null) // show box in place of missing argument\n        result[0] = createMmlNode(\"mo\",document.createTextNode(\"\\u25A1\"));\n      else AMremoveBrackets(result[0]);\n      str = result[1];\n      AMremoveBrackets(node);\n      node = createMmlNode(symbol.tag,node);\n      node.appendChild(result[0]);\n      newFrag.appendChild(node);\n      symbol = AMgetSymbol(str);\n    } \n    else if (node!=undefined) newFrag.appendChild(node);\n  } while ((symbol.ttype != RIGHTBRACKET && \n           (symbol.ttype != LEFTRIGHT || rightbracket)\n           || AMnestingDepth == 0) && symbol!=null && symbol.output!=\"\");\n  if (symbol.ttype == RIGHTBRACKET || symbol.ttype == LEFTRIGHT) {\n//    if (AMnestingDepth > 0) AMnestingDepth--;\n    var len = newFrag.childNodes.length;\n    if (len>0 && newFrag.childNodes[len-1].nodeName == \"mrow\" && len>1 &&\n      newFrag.childNodes[len-2].nodeName == \"mo\" &&\n      newFrag.childNodes[len-2].firstChild.nodeValue == \",\") { //matrix\n      var right = newFrag.childNodes[len-1].lastChild.firstChild.nodeValue;\n      if (right==\")\" || right==\"]\") {\n        var left = newFrag.childNodes[len-1].firstChild.firstChild.nodeValue;\n        if (left==\"(\" && right==\")\" && symbol.output != \"}\" || \n            left==\"[\" && right==\"]\") {\n        var pos = []; // positions of commas\n        var matrix = true;\n        var m = newFrag.childNodes.length;\n        for (i=0; matrix && i<m; i=i+2) {\n          pos[i] = [];\n          node = newFrag.childNodes[i];\n          if (matrix) matrix = node.nodeName==\"mrow\" && \n            (i==m-1 || node.nextSibling.nodeName==\"mo\" && \n            node.nextSibling.firstChild.nodeValue==\",\")&&\n            node.firstChild.firstChild.nodeValue==left &&\n            node.lastChild.firstChild.nodeValue==right;\n          if (matrix) \n            for (var j=0; j<node.childNodes.length; j++)\n              if (node.childNodes[j].firstChild.nodeValue==\",\")\n                pos[i][pos[i].length]=j;\n          if (matrix && i>1) matrix = pos[i].length == pos[i-2].length;\n        }\n        if (matrix) {\n          var row, frag, n, k, table = document.createDocumentFragment();\n          for (i=0; i<m; i=i+2) {\n            row = document.createDocumentFragment();\n            frag = document.createDocumentFragment();\n            node = newFrag.firstChild; // <mrow>(-,-,...,-,-)</mrow>\n            n = node.childNodes.length;\n            k = 0;\n            node.removeChild(node.firstChild); //remove (\n            for (j=1; j<n-1; j++) {\n              if (typeof pos[i][k] != \"undefined\" && j==pos[i][k]){\n                node.removeChild(node.firstChild); //remove ,\n                row.appendChild(createMmlNode(\"mtd\",frag));\n                k++;\n              } else frag.appendChild(node.firstChild);\n            }\n            row.appendChild(createMmlNode(\"mtd\",frag));\n            if (newFrag.childNodes.length>2) {\n              newFrag.removeChild(newFrag.firstChild); //remove <mrow>)</mrow>\n              newFrag.removeChild(newFrag.firstChild); //remove <mo>,</mo>\n            }\n            table.appendChild(createMmlNode(\"mtr\",row));\n          }\n          node = createMmlNode(\"mtable\",table);\n          if (typeof symbol.invisible == \"boolean\" && symbol.invisible) node.setAttribute(\"columnalign\",\"left\");\n          newFrag.replaceChild(node,newFrag.firstChild);\n        }\n       }\n      }\n    }\n    str = AMremoveCharsAndBlanks(str,symbol.input.length);\n    if (typeof symbol.invisible != \"boolean\" || !symbol.invisible) {\n      node = createMmlNode(\"mo\",document.createTextNode(symbol.output));\n      newFrag.appendChild(node);\n    }\n  }\n  return [newFrag,str];\n}\n\nfunction parseMath(str,latex) {\n  var frag, node;\n  AMnestingDepth = 0;\n  frag = latex ? LMparseExpr(str.replace(/^\\s+/g,\"\"),false,false)[0] : AMparseExpr(str.replace(/^\\s+/g,\"\"),false)[0];\n  node = createMmlNode(\"mstyle\",frag);\n  node.setAttribute(\"mathcolor\",mathcolor);\n  node.setAttribute(\"fontfamily\",mathfontfamily);\n  node.setAttribute(\"mathsize\",mathfontsize);\n  if (displaystyle) node.setAttribute(\"displaystyle\",\"true\");\n  node = createMmlNode(\"math\",node);\n  if (showasciiformulaonhover)                      //fixed by djhsu so newline\n    node.setAttribute(\"title\",str.replace(/\\s+/g,\" \"));//does not show in Gecko\n  return node;\n}\n\nfunction strarr2docFrag(arr, linebreaks, latex) {\n  var newFrag=document.createDocumentFragment();\n  var expr = false;\n  for (var i=0; i<arr.length; i++) {\n    if (expr) newFrag.appendChild(parseMath(arr[i],latex));\n    else {\n      var arri = (linebreaks ? arr[i].split(\"\\n\\n\") : [arr[i]]);\n      newFrag.appendChild(createElementXHTML(\"span\").\n      appendChild(document.createTextNode(arri[0])));\n      for (var j=1; j<arri.length; j++) {\n        newFrag.appendChild(createElementXHTML(\"p\"));\n        newFrag.appendChild(createElementXHTML(\"span\").\n        appendChild(document.createTextNode(arri[j])));\n      }\n    }\n    expr = !expr;\n  }\n  return newFrag;\n}\n\nfunction AMautomathrec(str) {\n//formula is a space (or start of str) followed by a maximal sequence of *two* or more tokens, possibly separated by runs of digits and/or space.\n//tokens are single letters (except a, A, I) and ASCIIMathML tokens\n  var texcommand = \"\\\\\\\\[a-zA-Z]+|\\\\\\\\\\\\s|\";\n  var ambigAMtoken = \"\\\\b(?:oo|lim|ln|int|oint|del|grad|aleph|prod|prop|sinh|cosh|tanh|cos|sec|pi|tt|fr|sf|sube|supe|sub|sup|det|mod|gcd|lcm|min|max|vec|ddot|ul|chi|eta|nu|mu)(?![a-z])|\";\n  var englishAMtoken = \"\\\\b(?:sum|ox|log|sin|tan|dim|hat|bar|dot)(?![a-z])|\";\n  var secondenglishAMtoken = \"|\\\\bI\\\\b|\\\\bin\\\\b|\\\\btext\\\\b\"; // took if and or not out\n  var simpleAMtoken = \"NN|ZZ|QQ|RR|CC|TT|AA|EE|sqrt|dx|dy|dz|dt|xx|vv|uu|nn|bb|cc|csc|cot|alpha|beta|delta|Delta|epsilon|gamma|Gamma|kappa|lambda|Lambda|omega|phi|Phi|Pi|psi|Psi|rho|sigma|Sigma|tau|theta|Theta|xi|Xi|zeta\"; // uuu nnn?\n  var letter = \"[a-zA-HJ-Z](?=(?:[^a-zA-Z]|$|\"+ambigAMtoken+englishAMtoken+simpleAMtoken+\"))|\";\n  var token = letter+texcommand+\"\\\\d+|[-()[\\\\]{}+=*&^_%\\\\\\@/<>,\\\\|!:;'~]|\\\\.(?!(?:\\x20|$))|\"+ambigAMtoken+englishAMtoken+simpleAMtoken;\n  var re = new RegExp(\"(^|\\\\s)(((\"+token+\")\\\\s?)((\"+token+secondenglishAMtoken+\")\\\\s?)+)([,.?]?(?=\\\\s|$))\",\"g\");\n  str = str.replace(re,\" `$2`$7\");\n  var arr = str.split(AMdelimiter1);\n  var re1 = new RegExp(\"(^|\\\\s)([b-zB-HJ-Z+*<>]|\"+texcommand+ambigAMtoken+simpleAMtoken+\")(\\\\s|\\\\n|$)\",\"g\");\n  var re2 = new RegExp(\"(^|\\\\s)([a-z]|\"+texcommand+ambigAMtoken+simpleAMtoken+\")([,.])\",\"g\"); // removed |\\d+ for now\n  for (i=0; i<arr.length; i++)   //single nonenglish tokens\n    if (i%2==0) {\n      arr[i] = arr[i].replace(re1,\" `$2`$3\");\n      arr[i] = arr[i].replace(re2,\" `$2`$3\");\n      arr[i] = arr[i].replace(/([{}[\\]])/,\"`$1`\");\n    }\n  str = arr.join(AMdelimiter1);\n  str = str.replace(/((^|\\s)\\([a-zA-Z]{2,}.*?)\\)`/g,\"$1`)\");  //fix parentheses\n  str = str.replace(/`(\\((a\\s|in\\s))(.*?[a-zA-Z]{2,}\\))/g,\"$1`$3\");  //fix parentheses\n  str = str.replace(/\\sin`/g,\"` in\");\n  str = str.replace(/`(\\(\\w\\)[,.]?(\\s|\\n|$))/g,\"$1`\");\n  str = str.replace(/`([0-9.]+|e.g|i.e)`(\\.?)/gi,\"$1$2\");\n  str = str.replace(/`([0-9.]+:)`/g,\"$1\");\n  return str;\n}\n\nfunction processNodeR(n, linebreaks,latex) {\n  var mtch, str, arr, frg, i;\n  if (n.childNodes.length == 0) {\n   if ((n.nodeType!=8 || linebreaks) &&\n    n.parentNode.nodeName!=\"form\" && n.parentNode.nodeName!=\"FORM\" &&\n    n.parentNode.nodeName!=\"textarea\" && n.parentNode.nodeName!=\"TEXTAREA\" /* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */) {\n    str = n.nodeValue;\n    if (!(str == null)) {\n      str = str.replace(/\\r\\n\\r\\n/g,\"\\n\\n\");\n      str = str.replace(/\\x20+/g,\" \");\n      str = str.replace(/\\s*\\r\\n/g,\" \");\n      if(latex) {\n// DELIMITERS:\n        mtch = (str.indexOf(\"\\$\")==-1 ? false : true);\n        str = str.replace(/([^\\\\])\\$/g,\"$1 \\$\");\n        str = str.replace(/^\\$/,\" \\$\");\t// in case \\$ at start of string\n        arr = str.split(\" \\$\");\n        for (i=0; i<arr.length; i++)\n\t  arr[i]=arr[i].replace(/\\\\\\$/g,\"\\$\");\n      } else {\n      mtch = false;\n      str = str.replace(new RegExp(AMescape1, \"g\"),\n              function(){mtch = true; return \"AMescape1\"});\n      str = str.replace(/\\\\?end{?a?math}?/i,\n              function(){automathrecognize = false; mtch = true; return \"\"});\n      str = str.replace(/amath\\b|\\\\begin{a?math}/i,\n              function(){automathrecognize = true; mtch = true; return \"\"});\n      arr = str.split(AMdelimiter1);\n      if (automathrecognize)\n        for (i=0; i<arr.length; i++)\n          if (i%2==0) arr[i] = AMautomathrec(arr[i]);\n      str = arr.join(AMdelimiter1);\n      arr = str.split(AMdelimiter1);\n      for (i=0; i<arr.length; i++) // this is a problem ************\n        arr[i]=arr[i].replace(/AMescape1/g,AMdelimiter1);\n      }\n      if (arr.length>1 || mtch) {\n        if (!noMathML) {\n          frg = strarr2docFrag(arr,n.nodeType==8,latex);\n          var len = frg.childNodes.length;\n          n.parentNode.replaceChild(frg,n);\n          return len-1;\n        } else return 0;\n      }\n    }\n   } else return 0;\n  } else if (n.nodeName!=\"math\") {\n    for (i=0; i<n.childNodes.length; i++)\n      i += processNodeR(n.childNodes[i], linebreaks,latex);\n  }\n  return 0;\n}\n\nfunction AMprocessNode(n, linebreaks, spanclassAM) {\n  var frag,st;\n  if (spanclassAM!=null) {\n    frag = document.getElementsByTagName(\"span\")\n    for (var i=0;i<frag.length;i++)\n      if (frag[i].className == \"AM\") \n        processNodeR(frag[i],linebreaks,false);\n  } else {\n    try {\n      st = n.innerHTML; // look for AMdelimiter on page\n    } catch(err) {}\n//alert(st)\n    if (st==null || /amath\\b|\\\\begin{a?math}/i.test(st) ||\n      st.indexOf(AMdelimiter1+\" \")!=-1 || st.slice(-1)==AMdelimiter1 ||\n      st.indexOf(AMdelimiter1+\"<\")!=-1 || st.indexOf(AMdelimiter1+\"\\n\")!=-1) {\n      processNodeR(n,linebreaks,false);\n    }\n  }\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n}\n\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n\n// all further global variables start with \"LM\"\n\n// Commented out by DRW to prevent 1/2 turning into a 2-line fraction\n// LMdiv   = {input:\"/\",\t tag:\"mfrac\", output:\"/\",    ttype:INFIX},\n// Commented out by DRW so that \" prints literally in equations\n// LMquote = {input:\"\\\"\",\t tag:\"mtext\", output:\"mbox\", ttype:TEXT};\n\nvar LMsymbols = [\n//Greek letters\n{input:\"\\\\alpha\",\ttag:\"mi\", output:\"\\u03B1\", ttype:CONST},\n{input:\"\\\\beta\",\ttag:\"mi\", output:\"\\u03B2\", ttype:CONST},\n{input:\"\\\\gamma\",\ttag:\"mi\", output:\"\\u03B3\", ttype:CONST},\n{input:\"\\\\delta\",\ttag:\"mi\", output:\"\\u03B4\", ttype:CONST},\n{input:\"\\\\epsilon\",\ttag:\"mi\", output:\"\\u03B5\", ttype:CONST},\n{input:\"\\\\varepsilon\",  tag:\"mi\", output:\"\\u025B\", ttype:CONST},\n{input:\"\\\\zeta\",\ttag:\"mi\", output:\"\\u03B6\", ttype:CONST},\n{input:\"\\\\eta\",\t\ttag:\"mi\", output:\"\\u03B7\", ttype:CONST},\n{input:\"\\\\theta\",\ttag:\"mi\", output:\"\\u03B8\", ttype:CONST},\n{input:\"\\\\vartheta\",\ttag:\"mi\", output:\"\\u03D1\", ttype:CONST},\n{input:\"\\\\iota\",\ttag:\"mi\", output:\"\\u03B9\", ttype:CONST},\n{input:\"\\\\kappa\",\ttag:\"mi\", output:\"\\u03BA\", ttype:CONST},\n{input:\"\\\\lambda\",\ttag:\"mi\", output:\"\\u03BB\", ttype:CONST},\n{input:\"\\\\mu\",\t\ttag:\"mi\", output:\"\\u03BC\", ttype:CONST},\n{input:\"\\\\nu\",\t\ttag:\"mi\", output:\"\\u03BD\", ttype:CONST},\n{input:\"\\\\xi\",\t\ttag:\"mi\", output:\"\\u03BE\", ttype:CONST},\n{input:\"\\\\pi\",\t\ttag:\"mi\", output:\"\\u03C0\", ttype:CONST},\n{input:\"\\\\varpi\",\ttag:\"mi\", output:\"\\u03D6\", ttype:CONST},\n{input:\"\\\\rho\",\t\ttag:\"mi\", output:\"\\u03C1\", ttype:CONST},\n{input:\"\\\\varrho\",\ttag:\"mi\", output:\"\\u03F1\", ttype:CONST},\n{input:\"\\\\varsigma\",\ttag:\"mi\", output:\"\\u03C2\", ttype:CONST},\n{input:\"\\\\sigma\",\ttag:\"mi\", output:\"\\u03C3\", ttype:CONST},\n{input:\"\\\\tau\",\t\ttag:\"mi\", output:\"\\u03C4\", ttype:CONST},\n{input:\"\\\\upsilon\",\ttag:\"mi\", output:\"\\u03C5\", ttype:CONST},\n{input:\"\\\\phi\",\t\ttag:\"mi\", output:\"\\u03C6\", ttype:CONST},\n{input:\"\\\\varphi\",\ttag:\"mi\", output:\"\\u03D5\", ttype:CONST},\n{input:\"\\\\chi\",\t\ttag:\"mi\", output:\"\\u03C7\", ttype:CONST},\n{input:\"\\\\psi\",\t\ttag:\"mi\", output:\"\\u03C8\", ttype:CONST},\n{input:\"\\\\omega\",\ttag:\"mi\", output:\"\\u03C9\", ttype:CONST},\n{input:\"\\\\Gamma\",\ttag:\"mo\", output:\"\\u0393\", ttype:CONST},\n{input:\"\\\\Delta\",\ttag:\"mo\", output:\"\\u0394\", ttype:CONST},\n{input:\"\\\\Theta\",\ttag:\"mo\", output:\"\\u0398\", ttype:CONST},\n{input:\"\\\\Lambda\",\ttag:\"mo\", output:\"\\u039B\", ttype:CONST},\n{input:\"\\\\Xi\",\t\ttag:\"mo\", output:\"\\u039E\", ttype:CONST},\n{input:\"\\\\Pi\",\t\ttag:\"mo\", output:\"\\u03A0\", ttype:CONST},\n{input:\"\\\\Sigma\",\ttag:\"mo\", output:\"\\u03A3\", ttype:CONST},\n{input:\"\\\\Upsilon\",\ttag:\"mo\", output:\"\\u03A5\", ttype:CONST},\n{input:\"\\\\Phi\",\t\ttag:\"mo\", output:\"\\u03A6\", ttype:CONST},\n{input:\"\\\\Psi\",\t\ttag:\"mo\", output:\"\\u03A8\", ttype:CONST},\n{input:\"\\\\Omega\",\ttag:\"mo\", output:\"\\u03A9\", ttype:CONST},\n\n//fractions\n{input:\"\\\\frac12\",\ttag:\"mo\", output:\"\\u00BD\", ttype:CONST},\n{input:\"\\\\frac14\",\ttag:\"mo\", output:\"\\u00BC\", ttype:CONST},\n{input:\"\\\\frac34\",\ttag:\"mo\", output:\"\\u00BE\", ttype:CONST},\n{input:\"\\\\frac13\",\ttag:\"mo\", output:\"\\u2153\", ttype:CONST},\n{input:\"\\\\frac23\",\ttag:\"mo\", output:\"\\u2154\", ttype:CONST},\n{input:\"\\\\frac15\",\ttag:\"mo\", output:\"\\u2155\", ttype:CONST},\n{input:\"\\\\frac25\",\ttag:\"mo\", output:\"\\u2156\", ttype:CONST},\n{input:\"\\\\frac35\",\ttag:\"mo\", output:\"\\u2157\", ttype:CONST},\n{input:\"\\\\frac45\",\ttag:\"mo\", output:\"\\u2158\", ttype:CONST},\n{input:\"\\\\frac16\",\ttag:\"mo\", output:\"\\u2159\", ttype:CONST},\n{input:\"\\\\frac56\",\ttag:\"mo\", output:\"\\u215A\", ttype:CONST},\n{input:\"\\\\frac18\",\ttag:\"mo\", output:\"\\u215B\", ttype:CONST},\n{input:\"\\\\frac38\",\ttag:\"mo\", output:\"\\u215C\", ttype:CONST},\n{input:\"\\\\frac58\",\ttag:\"mo\", output:\"\\u215D\", ttype:CONST},\n{input:\"\\\\frac78\",\ttag:\"mo\", output:\"\\u215E\", ttype:CONST},\n\n//binary operation symbols\n{input:\"\\\\pm\",\t\ttag:\"mo\", output:\"\\u00B1\", ttype:CONST},\n{input:\"\\\\mp\",\t\ttag:\"mo\", output:\"\\u2213\", ttype:CONST},\n{input:\"\\\\triangleleft\",tag:\"mo\", output:\"\\u22B2\", ttype:CONST},\n{input:\"\\\\triangleright\",tag:\"mo\",output:\"\\u22B3\", ttype:CONST},\n{input:\"\\\\cdot\",\ttag:\"mo\", output:\"\\u22C5\", ttype:CONST},\n{input:\"\\\\star\",\ttag:\"mo\", output:\"\\u22C6\", ttype:CONST},\n{input:\"\\\\ast\",\t\ttag:\"mo\", output:\"\\u002A\", ttype:CONST},\n{input:\"\\\\times\",\ttag:\"mo\", output:\"\\u00D7\", ttype:CONST},\n{input:\"\\\\div\",\t\ttag:\"mo\", output:\"\\u00F7\", ttype:CONST},\n{input:\"\\\\circ\",\ttag:\"mo\", output:\"\\u2218\", ttype:CONST},\n//{input:\"\\\\bullet\",\t  tag:\"mo\", output:\"\\u2219\", ttype:CONST},\n{input:\"\\\\bullet\",\ttag:\"mo\", output:\"\\u2022\", ttype:CONST},\n{input:\"\\\\oplus\",\ttag:\"mo\", output:\"\\u2295\", ttype:CONST},\n{input:\"\\\\ominus\",\ttag:\"mo\", output:\"\\u2296\", ttype:CONST},\n{input:\"\\\\otimes\",\ttag:\"mo\", output:\"\\u2297\", ttype:CONST},\n{input:\"\\\\bigcirc\",\ttag:\"mo\", output:\"\\u25CB\", ttype:CONST},\n{input:\"\\\\oslash\",\ttag:\"mo\", output:\"\\u2298\", ttype:CONST},\n{input:\"\\\\odot\",\ttag:\"mo\", output:\"\\u2299\", ttype:CONST},\n{input:\"\\\\land\",\ttag:\"mo\", output:\"\\u2227\", ttype:CONST},\n{input:\"\\\\wedge\",\ttag:\"mo\", output:\"\\u2227\", ttype:CONST},\n{input:\"\\\\lor\",\t\ttag:\"mo\", output:\"\\u2228\", ttype:CONST},\n{input:\"\\\\vee\",\t\ttag:\"mo\", output:\"\\u2228\", ttype:CONST},\n{input:\"\\\\cap\",\t\ttag:\"mo\", output:\"\\u2229\", ttype:CONST},\n{input:\"\\\\cup\",\t\ttag:\"mo\", output:\"\\u222A\", ttype:CONST},\n{input:\"\\\\sqcap\",\ttag:\"mo\", output:\"\\u2293\", ttype:CONST},\n{input:\"\\\\sqcup\",\ttag:\"mo\", output:\"\\u2294\", ttype:CONST},\n{input:\"\\\\uplus\",\ttag:\"mo\", output:\"\\u228E\", ttype:CONST},\n{input:\"\\\\amalg\",\ttag:\"mo\", output:\"\\u2210\", ttype:CONST},\n{input:\"\\\\bigtriangleup\",tag:\"mo\",output:\"\\u25B3\", ttype:CONST},\n{input:\"\\\\bigtriangledown\",tag:\"mo\",output:\"\\u25BD\", ttype:CONST},\n{input:\"\\\\dag\",\t\ttag:\"mo\", output:\"\\u2020\", ttype:CONST},\n{input:\"\\\\dagger\",\ttag:\"mo\", output:\"\\u2020\", ttype:CONST},\n{input:\"\\\\ddag\",\ttag:\"mo\", output:\"\\u2021\", ttype:CONST},\n{input:\"\\\\ddagger\",\ttag:\"mo\", output:\"\\u2021\", ttype:CONST},\n{input:\"\\\\lhd\",\t\ttag:\"mo\", output:\"\\u22B2\", ttype:CONST},\n{input:\"\\\\rhd\",\t\ttag:\"mo\", output:\"\\u22B3\", ttype:CONST},\n{input:\"\\\\unlhd\",\ttag:\"mo\", output:\"\\u22B4\", ttype:CONST},\n{input:\"\\\\unrhd\",\ttag:\"mo\", output:\"\\u22B5\", ttype:CONST},\n\n\n//BIG Operators\n{input:\"\\\\sum\",\t\ttag:\"mo\", output:\"\\u2211\", ttype:UNDEROVER},\n{input:\"\\\\prod\",\ttag:\"mo\", output:\"\\u220F\", ttype:UNDEROVER},\n{input:\"\\\\bigcap\",\ttag:\"mo\", output:\"\\u22C2\", ttype:UNDEROVER},\n{input:\"\\\\bigcup\",\ttag:\"mo\", output:\"\\u22C3\", ttype:UNDEROVER},\n{input:\"\\\\bigwedge\",\ttag:\"mo\", output:\"\\u22C0\", ttype:UNDEROVER},\n{input:\"\\\\bigvee\",\ttag:\"mo\", output:\"\\u22C1\", ttype:UNDEROVER},\n{input:\"\\\\bigsqcap\",\ttag:\"mo\", output:\"\\u2A05\", ttype:UNDEROVER},\n{input:\"\\\\bigsqcup\",\ttag:\"mo\", output:\"\\u2A06\", ttype:UNDEROVER},\n{input:\"\\\\coprod\",\ttag:\"mo\", output:\"\\u2210\", ttype:UNDEROVER},\n{input:\"\\\\bigoplus\",\ttag:\"mo\", output:\"\\u2A01\", ttype:UNDEROVER},\n{input:\"\\\\bigotimes\",\ttag:\"mo\", output:\"\\u2A02\", ttype:UNDEROVER},\n{input:\"\\\\bigodot\",\ttag:\"mo\", output:\"\\u2A00\", ttype:UNDEROVER},\n{input:\"\\\\biguplus\",\ttag:\"mo\", output:\"\\u2A04\", ttype:UNDEROVER},\n{input:\"\\\\int\",\t\ttag:\"mo\", output:\"\\u222B\", ttype:CONST},\n{input:\"\\\\oint\",\ttag:\"mo\", output:\"\\u222E\", ttype:CONST},\n\n//binary relation symbols\n{input:\":=\",\t\ttag:\"mo\", output:\":=\",\t   ttype:CONST},\n{input:\"\\\\lt\",\t\ttag:\"mo\", output:\"<\",\t   ttype:CONST},\n{input:\"\\\\gt\",\t\ttag:\"mo\", output:\">\",\t   ttype:CONST},\n{input:\"\\\\ne\",\t\ttag:\"mo\", output:\"\\u2260\", ttype:CONST},\n{input:\"\\\\neq\",\t\ttag:\"mo\", output:\"\\u2260\", ttype:CONST},\n{input:\"\\\\le\",\t\ttag:\"mo\", output:\"\\u2264\", ttype:CONST},\n{input:\"\\\\leq\",\t\ttag:\"mo\", output:\"\\u2264\", ttype:CONST},\n{input:\"\\\\leqslant\",\ttag:\"mo\", output:\"\\u2264\", ttype:CONST},\n{input:\"\\\\ge\",\t\ttag:\"mo\", output:\"\\u2265\", ttype:CONST},\n{input:\"\\\\geq\",\t\ttag:\"mo\", output:\"\\u2265\", ttype:CONST},\n{input:\"\\\\geqslant\",\ttag:\"mo\", output:\"\\u2265\", ttype:CONST},\n{input:\"\\\\equiv\",\ttag:\"mo\", output:\"\\u2261\", ttype:CONST},\n{input:\"\\\\ll\",\t\ttag:\"mo\", output:\"\\u226A\", ttype:CONST},\n{input:\"\\\\gg\",\t\ttag:\"mo\", output:\"\\u226B\", ttype:CONST},\n{input:\"\\\\doteq\",\ttag:\"mo\", output:\"\\u2250\", ttype:CONST},\n{input:\"\\\\prec\",\ttag:\"mo\", output:\"\\u227A\", ttype:CONST},\n{input:\"\\\\succ\",\ttag:\"mo\", output:\"\\u227B\", ttype:CONST},\n{input:\"\\\\preceq\",\ttag:\"mo\", output:\"\\u227C\", ttype:CONST},\n{input:\"\\\\succeq\",\ttag:\"mo\", output:\"\\u227D\", ttype:CONST},\n{input:\"\\\\subset\",\ttag:\"mo\", output:\"\\u2282\", ttype:CONST},\n{input:\"\\\\supset\",\ttag:\"mo\", output:\"\\u2283\", ttype:CONST},\n{input:\"\\\\subseteq\",\ttag:\"mo\", output:\"\\u2286\", ttype:CONST},\n{input:\"\\\\supseteq\",\ttag:\"mo\", output:\"\\u2287\", ttype:CONST},\n{input:\"\\\\sqsubset\",\ttag:\"mo\", output:\"\\u228F\", ttype:CONST},\n{input:\"\\\\sqsupset\",\ttag:\"mo\", output:\"\\u2290\", ttype:CONST},\n{input:\"\\\\sqsubseteq\",  tag:\"mo\", output:\"\\u2291\", ttype:CONST},\n{input:\"\\\\sqsupseteq\",  tag:\"mo\", output:\"\\u2292\", ttype:CONST},\n{input:\"\\\\sim\",\t\ttag:\"mo\", output:\"\\u223C\", ttype:CONST},\n{input:\"\\\\simeq\",\ttag:\"mo\", output:\"\\u2243\", ttype:CONST},\n{input:\"\\\\approx\",\ttag:\"mo\", output:\"\\u2248\", ttype:CONST},\n{input:\"\\\\cong\",\ttag:\"mo\", output:\"\\u2245\", ttype:CONST},\n{input:\"\\\\Join\",\ttag:\"mo\", output:\"\\u22C8\", ttype:CONST},\n{input:\"\\\\bowtie\",\ttag:\"mo\", output:\"\\u22C8\", ttype:CONST},\n{input:\"\\\\in\",\t\ttag:\"mo\", output:\"\\u2208\", ttype:CONST},\n{input:\"\\\\ni\",\t\ttag:\"mo\", output:\"\\u220B\", ttype:CONST},\n{input:\"\\\\owns\",\ttag:\"mo\", output:\"\\u220B\", ttype:CONST},\n{input:\"\\\\propto\",\ttag:\"mo\", output:\"\\u221D\", ttype:CONST},\n{input:\"\\\\vdash\",\ttag:\"mo\", output:\"\\u22A2\", ttype:CONST},\n{input:\"\\\\dashv\",\ttag:\"mo\", output:\"\\u22A3\", ttype:CONST},\n{input:\"\\\\models\",\ttag:\"mo\", output:\"\\u22A8\", ttype:CONST},\n{input:\"\\\\perp\",\ttag:\"mo\", output:\"\\u22A5\", ttype:CONST},\n{input:\"\\\\smile\",\ttag:\"mo\", output:\"\\u2323\", ttype:CONST},\n{input:\"\\\\frown\",\ttag:\"mo\", output:\"\\u2322\", ttype:CONST},\n{input:\"\\\\asymp\",\ttag:\"mo\", output:\"\\u224D\", ttype:CONST},\n{input:\"\\\\notin\",\ttag:\"mo\", output:\"\\u2209\", ttype:CONST},\n\n//matrices\n{input:\"\\\\begin{eqnarray}\",\toutput:\"X\",\tttype:MATRIX, invisible:true},\n{input:\"\\\\begin{array}\",\toutput:\"X\",\tttype:MATRIX, invisible:true},\n{input:\"\\\\\\\\\",\t\t\toutput:\"}&{\",\tttype:DEFINITION},\n{input:\"\\\\end{eqnarray}\",\toutput:\"}}\",\tttype:DEFINITION},\n{input:\"\\\\end{array}\",\t\toutput:\"}}\",\tttype:DEFINITION},\n\n//grouping and literal brackets -- ieval is for IE\n{input:\"\\\\big\",\t   tag:\"mo\", output:\"X\", atval:\"1.2\", ieval:\"2.2\", ttype:BIG},\n{input:\"\\\\Big\",\t   tag:\"mo\", output:\"X\", atval:\"1.6\", ieval:\"2.6\", ttype:BIG},\n{input:\"\\\\bigg\",   tag:\"mo\", output:\"X\", atval:\"2.2\", ieval:\"3.2\", ttype:BIG},\n{input:\"\\\\Bigg\",   tag:\"mo\", output:\"X\", atval:\"2.9\", ieval:\"3.9\", ttype:BIG},\n{input:\"\\\\left\",   tag:\"mo\", output:\"X\", ttype:LEFTBRACKET},\n{input:\"\\\\right\",  tag:\"mo\", output:\"X\", ttype:RIGHTBRACKET},\n{input:\"{\",\t   output:\"{\", ttype:LEFTBRACKET,  invisible:true},\n{input:\"}\",\t   output:\"}\", ttype:RIGHTBRACKET, invisible:true},\n\n{input:\"(\",\t   tag:\"mo\", output:\"(\",      atval:\"1\", ttype:STRETCHY},\n{input:\"[\",\t   tag:\"mo\", output:\"[\",      atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\lbrack\", tag:\"mo\", output:\"[\",      atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\{\",\t   tag:\"mo\", output:\"{\",      atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\lbrace\", tag:\"mo\", output:\"{\",      atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\langle\", tag:\"mo\", output:\"\\u2329\", atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\lfloor\", tag:\"mo\", output:\"\\u230A\", atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\lceil\",  tag:\"mo\", output:\"\\u2308\", atval:\"1\", ttype:STRETCHY},\n\n// rtag:\"mi\" causes space to be inserted before a following sin, cos, etc.\n// (see function LMparseExpr() )\n{input:\")\",\t  tag:\"mo\",output:\")\",\t    rtag:\"mi\",atval:\"1\",ttype:STRETCHY},\n{input:\"]\",\t  tag:\"mo\",output:\"]\",\t    rtag:\"mi\",atval:\"1\",ttype:STRETCHY},\n{input:\"\\\\rbrack\",tag:\"mo\",output:\"]\",\t    rtag:\"mi\",atval:\"1\",ttype:STRETCHY},\n{input:\"\\\\}\",\t  tag:\"mo\",output:\"}\",\t    rtag:\"mi\",atval:\"1\",ttype:STRETCHY},\n{input:\"\\\\rbrace\",tag:\"mo\",output:\"}\",\t    rtag:\"mi\",atval:\"1\",ttype:STRETCHY},\n{input:\"\\\\rangle\",tag:\"mo\",output:\"\\u232A\", rtag:\"mi\",atval:\"1\",ttype:STRETCHY},\n{input:\"\\\\rfloor\",tag:\"mo\",output:\"\\u230B\", rtag:\"mi\",atval:\"1\",ttype:STRETCHY},\n{input:\"\\\\rceil\", tag:\"mo\",output:\"\\u2309\", rtag:\"mi\",atval:\"1\",ttype:STRETCHY},\n\n// \"|\", \"\\\\|\", \"\\\\vert\" and \"\\\\Vert\" modified later: lspace = rspace = 0em\n{input:\"|\",\t\ttag:\"mo\", output:\"\\u2223\", atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\|\",\t\ttag:\"mo\", output:\"\\u2225\", atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\vert\",\ttag:\"mo\", output:\"\\u2223\", atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\Vert\",\ttag:\"mo\", output:\"\\u2225\", atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\mid\",\t\ttag:\"mo\", output:\"\\u2223\", atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\parallel\",\ttag:\"mo\", output:\"\\u2225\", atval:\"1\", ttype:STRETCHY},\n{input:\"/\",\t\ttag:\"mo\", output:\"/\",\tatval:\"1.01\", ttype:STRETCHY},\n{input:\"\\\\backslash\",\ttag:\"mo\", output:\"\\u2216\", atval:\"1\", ttype:STRETCHY},\n{input:\"\\\\setminus\",\ttag:\"mo\", output:\"\\\\\",\t   ttype:CONST},\n\n//miscellaneous symbols\n{input:\"\\\\!\",\t  tag:\"mspace\", atname:\"width\", atval:\"-0.167em\", ttype:SPACE},\n{input:\"\\\\,\",\t  tag:\"mspace\", atname:\"width\", atval:\"0.167em\", ttype:SPACE},\n{input:\"\\\\>\",\t  tag:\"mspace\", atname:\"width\", atval:\"0.222em\", ttype:SPACE},\n{input:\"\\\\:\",\t  tag:\"mspace\", atname:\"width\", atval:\"0.222em\", ttype:SPACE},\n{input:\"\\\\;\",\t  tag:\"mspace\", atname:\"width\", atval:\"0.278em\", ttype:SPACE},\n{input:\"~\",\t  tag:\"mspace\", atname:\"width\", atval:\"0.333em\", ttype:SPACE},\n{input:\"\\\\quad\",  tag:\"mspace\", atname:\"width\", atval:\"1em\", ttype:SPACE},\n{input:\"\\\\qquad\", tag:\"mspace\", atname:\"width\", atval:\"2em\", ttype:SPACE},\n//{input:\"{}\",\t\t  tag:\"mo\", output:\"\\u200B\", ttype:CONST}, // zero-width\n{input:\"\\\\prime\",\ttag:\"mo\", output:\"\\u2032\", ttype:CONST},\n{input:\"'\",\t\ttag:\"mo\", output:\"\\u02B9\", ttype:CONST},\n{input:\"''\",\t\ttag:\"mo\", output:\"\\u02BA\", ttype:CONST},\n{input:\"'''\",\t\ttag:\"mo\", output:\"\\u2034\", ttype:CONST},\n{input:\"''''\",\t\ttag:\"mo\", output:\"\\u2057\", ttype:CONST},\n{input:\"\\\\ldots\",\ttag:\"mo\", output:\"\\u2026\", ttype:CONST},\n{input:\"\\\\cdots\",\ttag:\"mo\", output:\"\\u22EF\", ttype:CONST},\n{input:\"\\\\vdots\",\ttag:\"mo\", output:\"\\u22EE\", ttype:CONST},\n{input:\"\\\\ddots\",\ttag:\"mo\", output:\"\\u22F1\", ttype:CONST},\n{input:\"\\\\forall\",\ttag:\"mo\", output:\"\\u2200\", ttype:CONST},\n{input:\"\\\\exists\",\ttag:\"mo\", output:\"\\u2203\", ttype:CONST},\n{input:\"\\\\Re\",\t\ttag:\"mo\", output:\"\\u211C\", ttype:CONST},\n{input:\"\\\\Im\",\t\ttag:\"mo\", output:\"\\u2111\", ttype:CONST},\n{input:\"\\\\aleph\",\ttag:\"mo\", output:\"\\u2135\", ttype:CONST},\n{input:\"\\\\hbar\",\ttag:\"mo\", output:\"\\u210F\", ttype:CONST},\n{input:\"\\\\ell\",\t\ttag:\"mo\", output:\"\\u2113\", ttype:CONST},\n{input:\"\\\\wp\",\t\ttag:\"mo\", output:\"\\u2118\", ttype:CONST},\n{input:\"\\\\emptyset\",\ttag:\"mo\", output:\"\\u2205\", ttype:CONST},\n{input:\"\\\\infty\",\ttag:\"mo\", output:\"\\u221E\", ttype:CONST},\n{input:\"\\\\surd\",\ttag:\"mo\", output:\"\\\\sqrt{}\", ttype:DEFINITION},\n{input:\"\\\\partial\",\ttag:\"mo\", output:\"\\u2202\", ttype:CONST},\n{input:\"\\\\nabla\",\ttag:\"mo\", output:\"\\u2207\", ttype:CONST},\n{input:\"\\\\triangle\",\ttag:\"mo\", output:\"\\u25B3\", ttype:CONST},\n{input:\"\\\\therefore\",\ttag:\"mo\", output:\"\\u2234\", ttype:CONST},\n{input:\"\\\\angle\",\ttag:\"mo\", output:\"\\u2220\", ttype:CONST},\n//{input:\"\\\\\\\\ \",\t  tag:\"mo\", output:\"\\u00A0\", ttype:CONST},\n{input:\"\\\\diamond\",\ttag:\"mo\", output:\"\\u22C4\", ttype:CONST},\n//{input:\"\\\\Diamond\",\t  tag:\"mo\", output:\"\\u25CA\", ttype:CONST},\n{input:\"\\\\Diamond\",\ttag:\"mo\", output:\"\\u25C7\", ttype:CONST},\n{input:\"\\\\neg\",\t\ttag:\"mo\", output:\"\\u00AC\", ttype:CONST},\n{input:\"\\\\lnot\",\ttag:\"mo\", output:\"\\u00AC\", ttype:CONST},\n{input:\"\\\\bot\",\t\ttag:\"mo\", output:\"\\u22A5\", ttype:CONST},\n{input:\"\\\\top\",\t\ttag:\"mo\", output:\"\\u22A4\", ttype:CONST},\n{input:\"\\\\square\",\ttag:\"mo\", output:\"\\u25AB\", ttype:CONST},\n{input:\"\\\\Box\",\t\ttag:\"mo\", output:\"\\u25A1\", ttype:CONST},\n{input:\"\\\\wr\",\t\ttag:\"mo\", output:\"\\u2240\", ttype:CONST},\n\n//standard functions\n//Note UNDEROVER *must* have tag:\"mo\" to work properly\n{input:\"\\\\arccos\", tag:\"mi\", output:\"arccos\", ttype:UNARY, func:true},\n{input:\"\\\\arcsin\", tag:\"mi\", output:\"arcsin\", ttype:UNARY, func:true},\n{input:\"\\\\arctan\", tag:\"mi\", output:\"arctan\", ttype:UNARY, func:true},\n{input:\"\\\\arg\",\t   tag:\"mi\", output:\"arg\",    ttype:UNARY, func:true},\n{input:\"\\\\cos\",\t   tag:\"mi\", output:\"cos\",    ttype:UNARY, func:true},\n{input:\"\\\\cosh\",   tag:\"mi\", output:\"cosh\",   ttype:UNARY, func:true},\n{input:\"\\\\cot\",\t   tag:\"mi\", output:\"cot\",    ttype:UNARY, func:true},\n{input:\"\\\\coth\",   tag:\"mi\", output:\"coth\",   ttype:UNARY, func:true},\n{input:\"\\\\csc\",\t   tag:\"mi\", output:\"csc\",    ttype:UNARY, func:true},\n{input:\"\\\\deg\",\t   tag:\"mi\", output:\"deg\",    ttype:UNARY, func:true},\n{input:\"\\\\det\",\t   tag:\"mi\", output:\"det\",    ttype:UNARY, func:true},\n{input:\"\\\\dim\",\t   tag:\"mi\", output:\"dim\",    ttype:UNARY, func:true}, //CONST?\n{input:\"\\\\exp\",\t   tag:\"mi\", output:\"exp\",    ttype:UNARY, func:true},\n{input:\"\\\\gcd\",\t   tag:\"mi\", output:\"gcd\",    ttype:UNARY, func:true}, //CONST?\n{input:\"\\\\hom\",\t   tag:\"mi\", output:\"hom\",    ttype:UNARY, func:true},\n{input:\"\\\\inf\",\t      tag:\"mo\", output:\"inf\",\t ttype:UNDEROVER},\n{input:\"\\\\ker\",\t   tag:\"mi\", output:\"ker\",    ttype:UNARY, func:true},\n{input:\"\\\\lg\",\t   tag:\"mi\", output:\"lg\",     ttype:UNARY, func:true},\n{input:\"\\\\lim\",\t      tag:\"mo\", output:\"lim\",\t ttype:UNDEROVER},\n{input:\"\\\\liminf\",    tag:\"mo\", output:\"liminf\", ttype:UNDEROVER},\n{input:\"\\\\limsup\",    tag:\"mo\", output:\"limsup\", ttype:UNDEROVER},\n{input:\"\\\\ln\",\t   tag:\"mi\", output:\"ln\",     ttype:UNARY, func:true},\n{input:\"\\\\log\",\t   tag:\"mi\", output:\"log\",    ttype:UNARY, func:true},\n{input:\"\\\\max\",\t      tag:\"mo\", output:\"max\",\t ttype:UNDEROVER},\n{input:\"\\\\min\",\t      tag:\"mo\", output:\"min\",\t ttype:UNDEROVER},\n{input:\"\\\\Pr\",\t   tag:\"mi\", output:\"Pr\",     ttype:UNARY, func:true},\n{input:\"\\\\sec\",\t   tag:\"mi\", output:\"sec\",    ttype:UNARY, func:true},\n{input:\"\\\\sin\",\t   tag:\"mi\", output:\"sin\",    ttype:UNARY, func:true},\n{input:\"\\\\sinh\",   tag:\"mi\", output:\"sinh\",   ttype:UNARY, func:true},\n{input:\"\\\\sup\",\t      tag:\"mo\", output:\"sup\",\t ttype:UNDEROVER},\n{input:\"\\\\tan\",\t   tag:\"mi\", output:\"tan\",    ttype:UNARY, func:true},\n{input:\"\\\\tanh\",   tag:\"mi\", output:\"tanh\",   ttype:UNARY, func:true},\n\n//arrows\n{input:\"\\\\gets\",\t\ttag:\"mo\", output:\"\\u2190\", ttype:CONST},\n{input:\"\\\\leftarrow\",\t\ttag:\"mo\", output:\"\\u2190\", ttype:CONST},\n{input:\"\\\\to\",\t\t\ttag:\"mo\", output:\"\\u2192\", ttype:CONST},\n{input:\"\\\\rightarrow\",\t\ttag:\"mo\", output:\"\\u2192\", ttype:CONST},\n{input:\"\\\\leftrightarrow\",\ttag:\"mo\", output:\"\\u2194\", ttype:CONST},\n{input:\"\\\\uparrow\",\t\ttag:\"mo\", output:\"\\u2191\", ttype:CONST},\n{input:\"\\\\downarrow\",\t\ttag:\"mo\", output:\"\\u2193\", ttype:CONST},\n{input:\"\\\\updownarrow\",\t\ttag:\"mo\", output:\"\\u2195\", ttype:CONST},\n{input:\"\\\\Leftarrow\",\t\ttag:\"mo\", output:\"\\u21D0\", ttype:CONST},\n{input:\"\\\\Rightarrow\",\t\ttag:\"mo\", output:\"\\u21D2\", ttype:CONST},\n{input:\"\\\\Leftrightarrow\",\ttag:\"mo\", output:\"\\u21D4\", ttype:CONST},\n{input:\"\\\\iff\", tag:\"mo\", output:\"~\\\\Longleftrightarrow~\", ttype:DEFINITION},\n{input:\"\\\\Uparrow\",\t\ttag:\"mo\", output:\"\\u21D1\", ttype:CONST},\n{input:\"\\\\Downarrow\",\t\ttag:\"mo\", output:\"\\u21D3\", ttype:CONST},\n{input:\"\\\\Updownarrow\",\t\ttag:\"mo\", output:\"\\u21D5\", ttype:CONST},\n{input:\"\\\\mapsto\",\t\ttag:\"mo\", output:\"\\u21A6\", ttype:CONST},\n{input:\"\\\\longleftarrow\",\ttag:\"mo\", output:\"\\u2190\", ttype:LONG},\n{input:\"\\\\longrightarrow\",\ttag:\"mo\", output:\"\\u2192\", ttype:LONG},\n{input:\"\\\\longleftrightarrow\",\ttag:\"mo\", output:\"\\u2194\", ttype:LONG},\n{input:\"\\\\Longleftarrow\",\ttag:\"mo\", output:\"\\u21D0\", ttype:LONG},\n{input:\"\\\\Longrightarrow\",\ttag:\"mo\", output:\"\\u21D2\", ttype:LONG},\n{input:\"\\\\implies\",\t\ttag:\"mo\", output:\"\\u21D2\", ttype:LONG},\n{input:\"\\\\Longleftrightarrow\",  tag:\"mo\", output:\"\\u21D4\", ttype:LONG},\n{input:\"\\\\longmapsto\",\t\ttag:\"mo\", output:\"\\u21A6\", ttype:CONST},\n\t\t\t\t\t\t\t// disaster if LONG\n\n//commands with argument\n\n{input:\"\\\\sqrt\",\ttag:\"msqrt\", output:\"sqrt\",\tttype:UNARY},\n{input:\"\\\\root\",\ttag:\"mroot\", output:\"root\",\tttype:BINARY},\n{input:\"\\\\frac\",\ttag:\"mfrac\", output:\"/\",\tttype:BINARY},\n{input:\"\\\\stackrel\",    tag:\"mover\", output:\"stackrel\", ttype:BINARY},\n{input:\"\\\\atop\",\ttag:\"mfrac\", output:\"\",\t\tttype:INFIX},\n{input:\"\\\\choose\",      tag:\"mfrac\", output:\"\",\t\tttype:INFIX},\n{input:\"_\",\t\ttag:\"msub\",  output:\"_\",\tttype:INFIX},\n{input:\"^\",\t\ttag:\"msup\",  output:\"^\",\tttype:INFIX},\n{input:\"\\\\mathrm\",\ttag:\"mtext\", output:\"text\",\tttype:TEXT},\n{input:\"\\\\mbox\",\ttag:\"mtext\", output:\"mbox\",\tttype:TEXT},\n\n//diacritical marks\n{input:\"\\\\acute\",\ttag:\"mover\",  output:\"\\u00B4\", ttype:UNARY, acc:true},\n//{input:\"\\\\acute\",\t  tag:\"mover\",  output:\"\\u0317\", ttype:UNARY, acc:true},\n//{input:\"\\\\acute\",\t  tag:\"mover\",  output:\"\\u0301\", ttype:UNARY, acc:true},\n//{input:\"\\\\grave\",\t  tag:\"mover\",  output:\"\\u0300\", ttype:UNARY, acc:true},\n//{input:\"\\\\grave\",\t  tag:\"mover\",  output:\"\\u0316\", ttype:UNARY, acc:true},\n{input:\"\\\\grave\",\ttag:\"mover\",  output:\"\\u0060\", ttype:UNARY, acc:true},\n{input:\"\\\\breve\",\ttag:\"mover\",  output:\"\\u02D8\", ttype:UNARY, acc:true},\n{input:\"\\\\check\",\ttag:\"mover\",  output:\"\\u02C7\", ttype:UNARY, acc:true},\n{input:\"\\\\dot\",\t\ttag:\"mover\",  output:\".\",      ttype:UNARY, acc:true},\n{input:\"\\\\ddot\",\ttag:\"mover\",  output:\"..\",     ttype:UNARY, acc:true},\n//{input:\"\\\\ddot\",\t  tag:\"mover\",  output:\"\\u00A8\", ttype:UNARY, acc:true},\n{input:\"\\\\mathring\",\ttag:\"mover\",  output:\"\\u00B0\", ttype:UNARY, acc:true},\n{input:\"\\\\vec\",\t\ttag:\"mover\",  output:\"\\u20D7\", ttype:UNARY, acc:true},\n{input:\"\\\\overrightarrow\",tag:\"mover\",output:\"\\u20D7\", ttype:UNARY, acc:true},\n{input:\"\\\\overleftarrow\",tag:\"mover\", output:\"\\u20D6\", ttype:UNARY, acc:true},\n{input:\"\\\\hat\",\t\ttag:\"mover\",  output:\"\\u005E\", ttype:UNARY, acc:true},\n{input:\"\\\\widehat\",\ttag:\"mover\",  output:\"\\u0302\", ttype:UNARY, acc:true},\n{input:\"\\\\tilde\",\ttag:\"mover\",  output:\"~\",      ttype:UNARY, acc:true},\n//{input:\"\\\\tilde\",\t  tag:\"mover\",  output:\"\\u0303\", ttype:UNARY, acc:true},\n{input:\"\\\\widetilde\",\ttag:\"mover\",  output:\"\\u02DC\", ttype:UNARY, acc:true},\n{input:\"\\\\bar\",\t\ttag:\"mover\",  output:\"\\u203E\", ttype:UNARY, acc:true},\n{input:\"\\\\overbrace\",\ttag:\"mover\",  output:\"\\u23B4\", ttype:UNARY, acc:true},\n{input:\"\\\\overline\",\ttag:\"mover\",  output:\"\\u00AF\", ttype:UNARY, acc:true},\n{input:\"\\\\underbrace\",  tag:\"munder\", output:\"\\u23B5\", ttype:UNARY, acc:true},\n{input:\"\\\\underline\",\ttag:\"munder\", output:\"\\u00AF\", ttype:UNARY, acc:true},\n//{input:\"underline\",\ttag:\"munder\", output:\"\\u0332\", ttype:UNARY, acc:true},\n\n//typestyles and fonts\n{input:\"\\\\displaystyle\",tag:\"mstyle\",atname:\"displaystyle\",atval:\"true\", ttype:UNARY},\n{input:\"\\\\textstyle\",tag:\"mstyle\",atname:\"displaystyle\",atval:\"false\", ttype:UNARY},\n{input:\"\\\\scriptstyle\",tag:\"mstyle\",atname:\"scriptlevel\",atval:\"1\", ttype:UNARY},\n{input:\"\\\\scriptscriptstyle\",tag:\"mstyle\",atname:\"scriptlevel\",atval:\"2\", ttype:UNARY},\n{input:\"\\\\textrm\", tag:\"mstyle\", output:\"\\\\mathrm\", ttype: DEFINITION},\n{input:\"\\\\mathbf\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"bold\", ttype:UNARY},\n{input:\"\\\\textbf\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"bold\", ttype:UNARY},\n{input:\"\\\\mathit\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"italic\", ttype:UNARY},\n{input:\"\\\\textit\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"italic\", ttype:UNARY},\n{input:\"\\\\mathtt\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"monospace\", ttype:UNARY},\n{input:\"\\\\texttt\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"monospace\", ttype:UNARY},\n{input:\"\\\\mathsf\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"sans-serif\", ttype:UNARY},\n{input:\"\\\\mathbb\", tag:\"mstyle\", atname:\"mathvariant\", atval:\"double-struck\", ttype:UNARY, codes:AMbbb},\n{input:\"\\\\mathcal\",tag:\"mstyle\", atname:\"mathvariant\", atval:\"script\", ttype:UNARY, codes:AMcal},\n{input:\"\\\\mathfrak\",tag:\"mstyle\",atname:\"mathvariant\", atval:\"fraktur\",ttype:UNARY, codes:AMfrk}\n];\n\nvar LMnames = []; //list of input symbols\n\nfunction LMremoveCharsAndBlanks(str,n) {\n//remove n characters and any following blanks\n  var st;\n  st = str.slice(n);\n  for (var i=0; i<st.length && st.charCodeAt(i)<=32; i=i+1);\n  return st.slice(i);\n}\n\nfunction LMgetSymbol(str) {\n//return maximal initial substring of str that appears in names\n//return null if there is none\n  var k = 0; //new pos\n  var j = 0; //old pos\n  var mk; //match pos\n  var st;\n  var tagst;\n  var match = \"\";\n  var more = true;\n  for (var i=1; i<=str.length && more; i++) {\n    st = str.slice(0,i); //initial substring of length i\n    j = k;\n    k = position(LMnames, st, j);\n    if (k<LMnames.length && str.slice(0,LMnames[k].length)==LMnames[k]){\n      match = LMnames[k];\n      mk = k;\n      i = match.length;\n    }\n    more = k<LMnames.length && str.slice(0,LMnames[k].length)>=LMnames[k];\n  }\n  LMpreviousSymbol=LMcurrentSymbol;\n  if (match!=\"\"){\n    LMcurrentSymbol=LMsymbols[mk].ttype;\n    return LMsymbols[mk];\n  }\n  LMcurrentSymbol=CONST;\n  k = 1;\n  st = str.slice(0,1); //take 1 character\n  if (\"0\"<=st && st<=\"9\") tagst = \"mn\";\n  else tagst = ((\"A\">st || st>\"Z\") && (\"a\">st || st>\"z\")?\"mo\":\"mi\");\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n  return {input:st, tag:tagst, output:st, ttype:CONST};\n}\n\n\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n\nvar LMpreviousSymbol,LMcurrentSymbol;\n\nfunction LMparseSexpr(str) { //parses str and returns [node,tailstr,(node)tag]\n  var symbol, node, result, result2, i, st,// rightvert = false,\n    newFrag = document.createDocumentFragment();\n  str = LMremoveCharsAndBlanks(str,0);\n  symbol = LMgetSymbol(str);             //either a token or a bracket or empty\n  if (symbol == null || symbol.ttype == RIGHTBRACKET)\n    return [null,str,null];\n  if (symbol.ttype == DEFINITION) {\n    str = symbol.output+LMremoveCharsAndBlanks(str,symbol.input.length);\n    symbol = LMgetSymbol(str);\n    if (symbol == null || symbol.ttype == RIGHTBRACKET)\n      return [null,str,null];\n  }\n  str = LMremoveCharsAndBlanks(str,symbol.input.length);\n  switch (symbol.ttype) {\n  case SPACE:\n    node = createMmlNode(symbol.tag);\n    node.setAttribute(symbol.atname,symbol.atval);\n    return [node,str,symbol.tag];\n  case UNDEROVER:\n    if (isIE) {\n      if (symbol.input.substr(0,4) == \"\\\\big\") {   // botch for missing symbols\n\tstr = \"\\\\\"+symbol.input.substr(4)+str;\t   // make \\bigcup = \\cup etc.\n\tsymbol = LMgetSymbol(str);\n\tsymbol.ttype = UNDEROVER;\n\tstr = LMremoveCharsAndBlanks(str,symbol.input.length);\n      }\n    }\n    return [createMmlNode(symbol.tag,\n\t\t\tdocument.createTextNode(symbol.output)),str,symbol.tag];\n  case CONST:\n    var output = symbol.output;\n    if (isIE) {\n      if (symbol.input == \"'\")\n\toutput = \"\\u2032\";\n      else if (symbol.input == \"''\")\n\toutput = \"\\u2033\";\n      else if (symbol.input == \"'''\")\n\toutput = \"\\u2033\\u2032\";\n      else if (symbol.input == \"''''\")\n\toutput = \"\\u2033\\u2033\";\n      else if (symbol.input == \"\\\\square\")\n\toutput = \"\\u25A1\";\t// same as \\Box\n      else if (symbol.input.substr(0,5) == \"\\\\frac\") {\n\t\t\t\t\t\t// botch for missing fractions\n\tvar denom = symbol.input.substr(6,1);\n\tif (denom == \"5\" || denom == \"6\") {\n\t  str = symbol.input.replace(/\\\\frac/,\"\\\\frac \")+str;\n\t  return [node,str,symbol.tag];\n\t}\n      }\n    }\n    node = createMmlNode(symbol.tag,document.createTextNode(output));\n    return [node,str,symbol.tag];\n  case LONG:  // added by DRW\n    node = createMmlNode(symbol.tag,document.createTextNode(symbol.output));\n    node.setAttribute(\"minsize\",\"1.5\");\n    node.setAttribute(\"maxsize\",\"1.5\");\n    node = createMmlNode(\"mover\",node);\n    node.appendChild(createMmlNode(\"mspace\"));\n    return [node,str,symbol.tag];\n  case STRETCHY:  // added by DRW\n    if (isIE && symbol.input == \"\\\\backslash\")\n\tsymbol.output = \"\\\\\";\t// doesn't expand, but then nor does \"\\u2216\"\n    node = createMmlNode(symbol.tag,document.createTextNode(symbol.output));\n    if (symbol.input == \"|\" || symbol.input == \"\\\\vert\" ||\n\tsymbol.input == \"\\\\|\" || symbol.input == \"\\\\Vert\") {\n\t  node.setAttribute(\"lspace\",\"0em\");\n\t  node.setAttribute(\"rspace\",\"0em\");\n    }\n    node.setAttribute(\"maxsize\",symbol.atval);  // don't allow to stretch here\n    if (symbol.rtag != null)\n      return [node,str,symbol.rtag];\n    else\n      return [node,str,symbol.tag];\n  case BIG:  // added by DRW\n    var atval = symbol.atval;\n    if (isIE)\n      atval = symbol.ieval;\n    symbol = LMgetSymbol(str);\n    if (symbol == null)\n\treturn [null,str,null];\n    str = LMremoveCharsAndBlanks(str,symbol.input.length);\n    node = createMmlNode(symbol.tag,document.createTextNode(symbol.output));\n    if (isIE) {\t\t// to get brackets to expand\n      var space = createMmlNode(\"mspace\");\n      space.setAttribute(\"height\",atval+\"ex\");\n      node = createMmlNode(\"mrow\",node);\n      node.appendChild(space);\n    } else {\t\t// ignored in IE\n      node.setAttribute(\"minsize\",atval);\n      node.setAttribute(\"maxsize\",atval);\n    }\n    return [node,str,symbol.tag];\n  case LEFTBRACKET:   //read (expr+)\n    if (symbol.input == \"\\\\left\") { // left what?\n      symbol = LMgetSymbol(str);\n      if (symbol != null) {\n\tif (symbol.input == \".\")\n\t  symbol.invisible = true;\n\tstr = LMremoveCharsAndBlanks(str,symbol.input.length);\n      }\n    }\n    result = LMparseExpr(str,true,false);\n    if (symbol==null ||\n\t(typeof symbol.invisible == \"boolean\" && symbol.invisible))\n      node = createMmlNode(\"mrow\",result[0]);\n    else {\n      node = createMmlNode(\"mo\",document.createTextNode(symbol.output));\n      node = createMmlNode(\"mrow\",node);\n      node.appendChild(result[0]);\n    }\n    return [node,result[1],result[2]];\n  case MATRIX:\t //read (expr+)\n    if (symbol.input == \"\\\\begin{array}\") {\n      var mask = \"\";\n      symbol = LMgetSymbol(str);\n      str = LMremoveCharsAndBlanks(str,0);\n      if (symbol == null)\n\tmask = \"l\";\n      else {\n\tstr = LMremoveCharsAndBlanks(str,symbol.input.length);\n\tif (symbol.input != \"{\")\n\t  mask = \"l\";\n\telse do {\n\t  symbol = LMgetSymbol(str);\n\t  if (symbol != null) {\n\t    str = LMremoveCharsAndBlanks(str,symbol.input.length);\n\t    if (symbol.input != \"}\")\n\t      mask = mask+symbol.input;\n\t  }\n\t} while (symbol != null && symbol.input != \"\" && symbol.input != \"}\");\n      }\n      result = LMparseExpr(\"{\"+str,true,true);\n//    if (result[0]==null) return [createMmlNode(\"mo\",\n//\t\t\t   document.createTextNode(symbol.input)),str];\n      node = createMmlNode(\"mtable\",result[0]);\n      mask = mask.replace(/l/g,\"left \");\n      mask = mask.replace(/r/g,\"right \");\n      mask = mask.replace(/c/g,\"center \");\n      node.setAttribute(\"columnalign\",mask);\n      node.setAttribute(\"displaystyle\",\"false\");\n      if (isIE)\n\treturn [node,result[1],null];\n// trying to get a *little* bit of space around the array\n// (IE already includes it)\n      var lspace = createMmlNode(\"mspace\");\n      lspace.setAttribute(\"width\",\"0.167em\");\n      var rspace = createMmlNode(\"mspace\");\n      rspace.setAttribute(\"width\",\"0.167em\");\n      var node1 = createMmlNode(\"mrow\",lspace);\n      node1.appendChild(node);\n      node1.appendChild(rspace);\n      return [node1,result[1],null];\n    } else {\t// eqnarray\n      result = LMparseExpr(\"{\"+str,true,true);\n      node = createMmlNode(\"mtable\",result[0]);\n      if (isIE)\n\tnode.setAttribute(\"columnspacing\",\"0.25em\"); // best in practice?\n      else\n\tnode.setAttribute(\"columnspacing\",\"0.167em\"); // correct (but ignored?)\n      node.setAttribute(\"columnalign\",\"right center left\");\n      node.setAttribute(\"displaystyle\",\"true\");\n      node = createMmlNode(\"mrow\",node);\n      return [node,result[1],null];\n    }\n  case TEXT:\n      if (str.charAt(0)==\"{\") i=str.indexOf(\"}\");\n      else i = 0;\n      if (i==-1)\n\t\t i = str.length;\n      st = str.slice(1,i);\n      if (st.charAt(0) == \" \") {\n\tnode = createMmlNode(\"mspace\");\n\tnode.setAttribute(\"width\",\"0.33em\");\t// was 1ex\n\tnewFrag.appendChild(node);\n      }\n      newFrag.appendChild(\n        createMmlNode(symbol.tag,document.createTextNode(st)));\n      if (st.charAt(st.length-1) == \" \") {\n\tnode = createMmlNode(\"mspace\");\n\tnode.setAttribute(\"width\",\"0.33em\");\t// was 1ex\n\tnewFrag.appendChild(node);\n      }\n      str = LMremoveCharsAndBlanks(str,i+1);\n      return [createMmlNode(\"mrow\",newFrag),str,null];\n  case UNARY:\n      result = LMparseSexpr(str);\n      if (result[0]==null) return [createMmlNode(symbol.tag,\n                             document.createTextNode(symbol.output)),str];\n      if (typeof symbol.func == \"boolean\" && symbol.func) { // functions hack\n\tst = str.charAt(0);\n//\tif (st==\"^\" || st==\"_\" || st==\"/\" || st==\"|\" || st==\",\") {\n\tif (st==\"^\" || st==\"_\" || st==\",\") {\n\t  return [createMmlNode(symbol.tag,\n\t\t    document.createTextNode(symbol.output)),str,symbol.tag];\n        } else {\n\t  node = createMmlNode(\"mrow\",\n\t   createMmlNode(symbol.tag,document.createTextNode(symbol.output)));\n\t  if (isIE) {\n\t    var space = createMmlNode(\"mspace\");\n\t    space.setAttribute(\"width\",\"0.167em\");\n\t    node.appendChild(space);\n\t  }\n\t  node.appendChild(result[0]);\n\t  return [node,result[1],symbol.tag];\n        }\n      }\n      if (symbol.input == \"\\\\sqrt\") {\t\t// sqrt\n\tif (isIE) {\t// set minsize, for \\surd\n\t  var space = createMmlNode(\"mspace\");\n\t  space.setAttribute(\"height\",\"1.2ex\");\n\t  space.setAttribute(\"width\",\"0em\");\t// probably no effect\n\t  node = createMmlNode(symbol.tag,result[0])\n//\t  node.setAttribute(\"minsize\",\"1\");\t// ignored\n//\t  node = createMmlNode(\"mrow\",node);  // hopefully unnecessary\n\t  node.appendChild(space);\n\t  return [node,result[1],symbol.tag];\n\t} else\n\t  return [createMmlNode(symbol.tag,result[0]),result[1],symbol.tag];\n      } else if (typeof symbol.acc == \"boolean\" && symbol.acc) {   // accent\n        node = createMmlNode(symbol.tag,result[0]);\n\tvar output = symbol.output;\n\tif (isIE) {\n\t\tif (symbol.input == \"\\\\hat\")\n\t\t\toutput = \"\\u0302\";\n\t\telse if (symbol.input == \"\\\\widehat\")\n\t\t\toutput = \"\\u005E\";\n\t\telse if (symbol.input == \"\\\\bar\")\n\t\t\toutput = \"\\u00AF\";\n\t\telse if (symbol.input == \"\\\\grave\")\n\t\t\toutput = \"\\u0300\";\n\t\telse if (symbol.input == \"\\\\tilde\")\n\t\t\toutput = \"\\u0303\";\n\t}\n\tvar node1 = createMmlNode(\"mo\",document.createTextNode(output));\n\tif (symbol.input == \"\\\\vec\" || symbol.input == \"\\\\check\")\n\t\t\t\t\t\t// don't allow to stretch\n\t    node1.setAttribute(\"maxsize\",\"1.2\");\n\t\t // why doesn't \"1\" work?  \\vec nearly disappears in firefox\n\tif (isIE && symbol.input == \"\\\\bar\")\n\t    node1.setAttribute(\"maxsize\",\"0.5\");\n\tif (symbol.input == \"\\\\underbrace\" || symbol.input == \"\\\\underline\")\n\t  node1.setAttribute(\"accentunder\",\"true\");\n\telse\n\t  node1.setAttribute(\"accent\",\"true\");\n\tnode.appendChild(node1);\n\tif (symbol.input == \"\\\\overbrace\" || symbol.input == \"\\\\underbrace\")\n\t  node.ttype = UNDEROVER;\n\treturn [node,result[1],symbol.tag];\n      } else {\t\t\t      // font change or displaystyle command\n        if (!isIE && typeof symbol.codes != \"undefined\") {\n          for (i=0; i<result[0].childNodes.length; i++)\n            if (result[0].childNodes[i].nodeName==\"mi\" || result[0].nodeName==\"mi\") {\n              st = (result[0].nodeName==\"mi\"?result[0].firstChild.nodeValue:\n                              result[0].childNodes[i].firstChild.nodeValue);\n              var newst = [];\n              for (var j=0; j<st.length; j++)\n                if (st.charCodeAt(j)>64 && st.charCodeAt(j)<91) newst = newst +\n                  String.fromCharCode(symbol.codes[st.charCodeAt(j)-65]);\n                else newst = newst + st.charAt(j);\n              if (result[0].nodeName==\"mi\")\n                result[0]=createMmlNode(\"mo\").\n                          appendChild(document.createTextNode(newst));\n              else result[0].replaceChild(createMmlNode(\"mo\").\n          appendChild(document.createTextNode(newst)),result[0].childNodes[i]);\n            }\n        }\n        node = createMmlNode(symbol.tag,result[0]);\n        node.setAttribute(symbol.atname,symbol.atval);\n\tif (symbol.input == \"\\\\scriptstyle\" ||\n\t    symbol.input == \"\\\\scriptscriptstyle\")\n\t\tnode.setAttribute(\"displaystyle\",\"false\");\n\treturn [node,result[1],symbol.tag];\n      }\n  case BINARY:\n    result = LMparseSexpr(str);\n    if (result[0]==null) return [createMmlNode(\"mo\",\n\t\t\t   document.createTextNode(symbol.input)),str,null];\n    result2 = LMparseSexpr(result[1]);\n    if (result2[0]==null) return [createMmlNode(\"mo\",\n\t\t\t   document.createTextNode(symbol.input)),str,null];\n    if (symbol.input==\"\\\\root\" || symbol.input==\"\\\\stackrel\")\n      newFrag.appendChild(result2[0]);\n    newFrag.appendChild(result[0]);\n    if (symbol.input==\"\\\\frac\") newFrag.appendChild(result2[0]);\n    return [createMmlNode(symbol.tag,newFrag),result2[1],symbol.tag];\n  case INFIX:\n    str = LMremoveCharsAndBlanks(str,symbol.input.length);\n    return [createMmlNode(\"mo\",document.createTextNode(symbol.output)),\n\tstr,symbol.tag];\n  default:\n    return [createMmlNode(symbol.tag,        //its a constant\n\tdocument.createTextNode(symbol.output)),str,symbol.tag];\n  }\n}\n\nfunction LMparseIexpr(str) {\n  var symbol, sym1, sym2, node, result, tag, underover;\n  str = LMremoveCharsAndBlanks(str,0);\n  sym1 = LMgetSymbol(str);\n  result = LMparseSexpr(str);\n  node = result[0];\n  str = result[1];\n  tag = result[2];\n  symbol = LMgetSymbol(str);\n  if (symbol.ttype == INFIX) {\n    str = LMremoveCharsAndBlanks(str,symbol.input.length);\n    result = LMparseSexpr(str);\n    if (result[0] == null) // show box in place of missing argument\n      result[0] = createMmlNode(\"mo\",document.createTextNode(\"\\u25A1\"));\n    str = result[1];\n    tag = result[2];\n    if (symbol.input == \"_\" || symbol.input == \"^\") {\n      sym2 = LMgetSymbol(str);\n      tag = null;\t// no space between x^2 and a following sin, cos, etc.\n// This is for \\underbrace and \\overbrace\n      underover = ((sym1.ttype == UNDEROVER) || (node.ttype == UNDEROVER));\n//    underover = (sym1.ttype == UNDEROVER);\n      if (symbol.input == \"_\" && sym2.input == \"^\") {\n        str = LMremoveCharsAndBlanks(str,sym2.input.length);\n        var res2 = LMparseSexpr(str);\n\tstr = res2[1];\n\ttag = res2[2];  // leave space between x_1^2 and a following sin etc.\n        node = createMmlNode((underover?\"munderover\":\"msubsup\"),node);\n        node.appendChild(result[0]);\n        node.appendChild(res2[0]);\n      } else if (symbol.input == \"_\") {\n\tnode = createMmlNode((underover?\"munder\":\"msub\"),node);\n        node.appendChild(result[0]);\n      } else {\n\tnode = createMmlNode((underover?\"mover\":\"msup\"),node);\n        node.appendChild(result[0]);\n      }\n      node = createMmlNode(\"mrow\",node); // so sum does not stretch\n    } else {\n      node = createMmlNode(symbol.tag,node);\n      if (symbol.input == \"\\\\atop\" || symbol.input == \"\\\\choose\")\n\tnode.setAttribute(\"linethickness\",\"0ex\");\n      node.appendChild(result[0]);\n      if (symbol.input == \"\\\\choose\")\n\tnode = createMmlNode(\"mfenced\",node);\n    }\n  }\n  return [node,str,tag];\n}\n\nfunction LMparseExpr(str,rightbracket,matrix) {\n  var symbol, node, result, i, tag,\n  newFrag = document.createDocumentFragment();\n  do {\n    str = LMremoveCharsAndBlanks(str,0);\n    result = LMparseIexpr(str);\n    node = result[0];\n    str = result[1];\n    tag = result[2];\n    symbol = LMgetSymbol(str);\n    if (node!=undefined) {\n      if ((tag == \"mn\" || tag == \"mi\") && symbol!=null &&\n\ttypeof symbol.func == \"boolean\" && symbol.func) {\n\t\t\t// Add space before \\sin in 2\\sin x or x\\sin x\n\t  var space = createMmlNode(\"mspace\");\n\t  space.setAttribute(\"width\",\"0.167em\");\n\t  node = createMmlNode(\"mrow\",node);\n\t  node.appendChild(space);\n      }\n      newFrag.appendChild(node);\n    }\n  } while ((symbol.ttype != RIGHTBRACKET)\n        && symbol!=null && symbol.output!=\"\");\n  tag = null;\n  if (symbol.ttype == RIGHTBRACKET) {\n    if (symbol.input == \"\\\\right\") { // right what?\n      str = LMremoveCharsAndBlanks(str,symbol.input.length);\n      symbol = LMgetSymbol(str);\n      if (symbol != null && symbol.input == \".\")\n\tsymbol.invisible = true;\n      if (symbol != null)\n\ttag = symbol.rtag;\n    }\n    if (symbol!=null)\n      str = LMremoveCharsAndBlanks(str,symbol.input.length); // ready to return\n    var len = newFrag.childNodes.length;\n    if (matrix &&\n      len>0 && newFrag.childNodes[len-1].nodeName == \"mrow\" && len>1 &&\n      newFrag.childNodes[len-2].nodeName == \"mo\" &&\n      newFrag.childNodes[len-2].firstChild.nodeValue == \"&\") { //matrix\n\tvar pos = []; // positions of ampersands\n        var m = newFrag.childNodes.length;\n        for (i=0; matrix && i<m; i=i+2) {\n          pos[i] = [];\n          node = newFrag.childNodes[i];\n\t  for (var j=0; j<node.childNodes.length; j++)\n\t    if (node.childNodes[j].firstChild.nodeValue==\"&\")\n\t      pos[i][pos[i].length]=j;\n        }\n\tvar row, frag, n, k, table = document.createDocumentFragment();\n\tfor (i=0; i<m; i=i+2) {\n\t  row = document.createDocumentFragment();\n\t  frag = document.createDocumentFragment();\n\t  node = newFrag.firstChild; // <mrow> -&-&...&-&- </mrow>\n\t  n = node.childNodes.length;\n\t  k = 0;\n\t  for (j=0; j<n; j++) {\n\t    if (typeof pos[i][k] != \"undefined\" && j==pos[i][k]){\n\t      node.removeChild(node.firstChild); //remove &\n\t      row.appendChild(createMmlNode(\"mtd\",frag));\n\t      k++;\n\t    } else frag.appendChild(node.firstChild);\n\t  }\n\t  row.appendChild(createMmlNode(\"mtd\",frag));\n\t  if (newFrag.childNodes.length>2) {\n\t    newFrag.removeChild(newFrag.firstChild); //remove <mrow> </mrow>\n\t    newFrag.removeChild(newFrag.firstChild); //remove <mo>&</mo>\n\t  }\n\t  table.appendChild(createMmlNode(\"mtr\",row));\n\t}\n\treturn [table,str];\n    }\n    if (typeof symbol.invisible != \"boolean\" || !symbol.invisible) {\n      node = createMmlNode(\"mo\",document.createTextNode(symbol.output));\n      newFrag.appendChild(node);\n    }\n  }\n  return [newFrag,str,tag];\n}\n\nvar tcnt = 0, dcnt = 0; //theorem and definition counters\n\nfunction simpleLaTeXformatting(st) {\n  st = st.replace(/\\$\\$((.|\\n)*?)\\$\\$/g,\"<p align=\\\"center\\\">$\\\\displaystyle{$1}$</p>\");\n  st = st.replace(/\\\\begin{(theorem|lemma|proposition|corollary)}((.|\\n)*?)\\\\end{\\1}/g,function(r,s,t){tcnt++; return \"<b>\"+s.charAt(0).toUpperCase()+s.slice(1)+\" \"+tcnt+\".</b> <i>\"+t.replace(/^\\s*<\\/?\\w+\\/?>|\\s*<\\/?\\w+\\/?>$/g,\"\")+\"</i>\"});\n  st = st.replace(/\\\\begin{(definition|example|remark|problem|exercise|conjecture|solution)}((.|\\n)*?)\\\\end{\\1}/g,function(r,s,t){dcnt++; return \"<b>\"+s.charAt(0).toUpperCase()+s.slice(1)+\" \"+dcnt+\".</b> \"+t.replace(/^\\s*<\\/?\\w+\\/?>|\\s*<\\/?\\w+\\/?>$/g,\"\")});\n  st = st.replace(/\\\\begin{proof}((.|\\n)*?)\\\\end{proof}/g,function(s,t){return \"<i>Proof:</i> \"+t.replace(/^\\s*<\\/?\\w+\\/?>|\\s*<\\/?\\w+\\/?>$/g,\"\")+\" &#x25A1;\"});\n  st = st.replace(/\\\\emph{(.*?)}/g,\"<em>$1</em>\");\n  st = st.replace(/\\\\textbf{(.*?)}/g,\"<b>$1</b>\");\n  st = st.replace(/\\\\cite{(.*?)}/g,\"[$1]\");\n  st = st.replace(/\\\\chapter{(.*?)}/g,\"<h2>$1</h2>\");\n  st = st.replace(/\\\\section{(.*?)}(\\s*<\\/?(br|p)\\s?\\/?>)?/g,\"<h3>$1</h3>\");\n  st = st.replace(/\\\\subsection{((.|\\n)*?)}/g,\"<h4>$1</h4>\");\n  st = st.replace(/\\\\begin{itemize}(\\s*<\\/?(br|p)\\s?\\/?>)?/g,\"<ul>\");\n  st = st.replace(/\\\\item\\s((.|\\n)*?)(?=(\\\\item|\\\\end))/g,\"<li>$1</li>\");\n  st = st.replace(/\\\\end{itemize}(\\s*<\\/?(br|p)\\s?\\/?>)?/g,\"</ul>\");\n  st = st.replace(/\\\\begin{enumerate}(\\s*<\\/?(br|p)\\s?\\/?>)?/g,\"<ol>\");\n  st = st.replace(/\\\\end{enumerate}(\\s*<\\/?(br|p)\\s?\\/?>)?/g,\"</ol>\");\n  st = st.replace(/\\\\item\\[(.*?)]{(.*?)}/g,\"<dt>$1</dt><dd>$2</dd>\");\n  st = st.replace(/\\\\begin{description}/g,\"<dl>\");\n  st = st.replace(/\\\\end{description}/g,\"</dl>\");\n  st = st.replace(/\\\\newline\\b/g,\"<br/>\");\n  st = st.replace(/\\\\newpage\\b/g,\"<br style=\\\"page-break-after:always;\\\">\");\n  st = st.replace(/\\\\par\\b/g,\"<p>&nbsp;</p>\");\n  st = st.replace(/\\\\bigskip/g,\"<p style=\\\"margin-bottom:0.5in\\\">&nbsp;</p>\");\n  st = st.replace(/\\\\medskip/g,\"<p style=\\\"margin-bottom:0.3in\\\">&nbsp;</p>\");\n  st = st.replace(/\\\\smallskip/g,\"<p style=\\\"margin-bottom:0.15in\\\">&nbsp;</p>\");\n  st = st.replace(/\\\\begin{center}((.|\\n)*?)\\\\end{center}/g,\"<center>$1</center>\");\n  return st\n}\n\nfunction ASCIIandgraphformatting(st) {\n  st = st.replace(/<sup>(.*?)<\\/sup>(\\s|(\\S))/gi,\"^{$1} $3\");\n//st = st.replace(/<\\/?font.*?>/gi,\"\"); // do this only in amath...endamath\n  st = st.replace(/(Proof:)/g,\"<i>$1</i>\");\n  st = st.replace(/QED/g,\"&nbsp; &nbsp; &#x25A1;\");\n  st = st.replace(/(\\\\?end{?a?math}?)/ig,\"<span></span>$1\");\n  st = st.replace(/(\\bamath\\b|\\\\begin{a?math})/ig,\"<span></span>$1\");\n  st = st.replace(/([>\\n])(Theorem|Lemma|Proposition|Corollary|Definition|Example|Remark|Problem|Exercise|Conjecture|Solution)(:|\\W\\W?(\\w|\\s|-|\\.)*?\\W?:)/g,\"$1<b>$2$3</b>\");\n  st = st.replace(/<embed\\s+class\\s?=\\s?\"?ASCIIsvg\"?/gi,\"<embed class=\\\"ASCIIsvg\\\" src=\\\"\"+dsvglocation+\"d.svg\\\" wmode=\\\"transparent\\\"\");\n  st = st.replace(/(?:\\\\begin{a?graph}|\\bagraph|\\(:graph\\s)((.|\\n)*?)(?:\\\\end{a?graph}|enda?graph|:\\))/g,function(s,t){return \"<table><tr><td><div class=\\\"ASCIIsvg\\\"><embed class=\\\"ASCIIsvg\\\" src=\\\"\"+dsvglocation+\"d.svg\\\" wmode=\\\"transparent\\\" script=\\'\"+t.replace(/<\\/?(br|p|pre)\\s?\\/?>/gi,\"\\n\")+\"\\'/></div></td></tr></table>\"});\n  st = st.replace(/insertASCIIMathCalculator/g,\"<div class=\\\"ASCIIMathCalculator\\\"></div>\");\n//alert(dsvglocation)\n  return st\n}\n\nfunction LMprocessNode(n) {\n  var frag,st;\n  try {\n    st = n.innerHTML;\n  } catch(err) {}\n  var am = /amath\\b|graph/i.test(st);\n  if ((st==null || st.indexOf(\"\\$ \")!=-1 || st.indexOf(\"\\$<\")!=-1 || \n       st.indexOf(\"\\\\begin\")!=-1 || am || st.slice(-1)==\"$\" ||\n       st.indexOf(\"\\$\\n\")!=-1)&& !/edit-content|HTMLArea|wikiedit|wpTextbox1/.test(st)){\n    if (!avoidinnerHTML && translateLaTeXformatting) \n      st = simpleLaTeXformatting(st);\n    if (st!=null && am && !avoidinnerHTML) {\n      st = ASCIIandgraphformatting(st);\n    }\n    st = st.replace(/%7E/g,\"~\"); // else PmWiki has url issues\n//alert(st)\n    if (!avoidinnerHTML) n.innerHTML = st;\n    processNodeR(n,false,true);\n  }\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n}\n\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n\n// you can change these\nvar checkIfSVGavailable = true;\nvar notifyIfNoSVG = true;\nvar alertIfNoSVG = false;\nvar noSVG = false;\n\n// global defaults used if not specified by graph (you can change these)\nvar defaultwidth = 300; defaultheight = 200;   // in pixels\nvar defaultxmin = -5.5; defaultxmax = 5.5;     // in usercoords\nvar defaultborder = 0; border = defaultborder; // in pixel\nvar defaultstrokewidth = \"1\"; // default line width in pixel\nvar defaultstroke = \"blue\";   // default line color\nvar defaultstrokeopacity = 1; // transparent = 0, solid =1\nvar defaultstrokedasharray = null; // \"10,10\" gives 10px long dashes\nvar defaultfill = \"none\";        // default fill color\nvar defaultfillopacity = 1;      // transparent = 0, solid =1\nvar defaultfontstyle = \"normal\"; // default text shape normal|italic|inherit\nvar defaultfontfamily = \"times\"; // default font times|ariel|helvetica|...\nvar defaultfontsize = \"16\";      // default size (scaled automatically)\nvar defaultfontweight = \"normal\";// normal|bold|bolder|lighter|100|...|900\nvar defaultfontstroke = \"none\";  // default font outline color\nvar defaultfontfill = \"none\";    // default font color\nvar defaultmarker = \"none\";      // \"dot\" | \"arrow\" | \"+\" | \"-\" | \"|\"\nvar defaultendpoints = \"\";       // \"c-d\" where c is <|o|* and d is >|o|*\n\n// global values used for all pictures (you can change these)\nvar showcoordinates = true;\nvar markerstrokewidth = \"1\";\nvar markerstroke = \"black\";\nvar markerfill = \"yellow\";\nvar markersize = 4;\nvar arrowfill = stroke;\nvar dotradius = 4;\nvar ticklength = 4;\nvar axesstroke = \"black\";\nvar gridstroke = \"grey\";\nvar backgroundstyle = \"fill-opacity:0; fill:white\";\nvar singlelettersitalic = true;\n\n// internal variables (probably no need to change these)\nvar picturepos = null; // position of picture relative to top of HTML page\nvar xunitlength;       // in pixels, used to convert to user coordinates\nvar yunitlength;       // in pixels\nvar origin = [0,0];    // in pixels (default is bottom left corner)\nvar above = \"above\";   // shorthands (to avoid typing quotes)\nvar below = \"below\";\nvar left = \"left\";\nvar right = \"right\";\nvar aboveleft = \"aboveleft\";\nvar aboveright = \"aboveright\";\nvar belowleft = \"belowleft\";\nvar belowright = \"belowright\";\nvar xmin, xmax, ymin, ymax, xscl, yscl, \n    xgrid, ygrid, xtick, ytick, initialized;\nvar strokewidth, strokedasharray, stroke, fill, strokeopacity, fillopacity;\nvar fontstyle, fontfamily, fontsize, fontweight, fontstroke, fontfill;\nvar marker, endpoints, dynamic = {};\nvar picture, svgpicture, doc, width, height;\nvar isIE = document.createElementNS==null;\n\n//this is not used! var cpi = \"\\u03C0\", ctheta = \"\\u03B8\";      // character for pi, theta\nvar log = function(x) { return ln(x)/ln(10) };\nvar pi = Math.PI, e = Math.E, ln = Math.log, sqrt = Math.sqrt;\nvar floor = Math.floor, ceil = Math.ceil, abs = Math.abs;\nvar sin = Math.sin, cos = Math.cos, tan = Math.tan;\nvar arcsin = Math.asin, arccos = Math.acos, arctan = Math.atan;\nvar sec = function(x) { return 1/Math.cos(x) };\nvar csc = function(x) { return 1/Math.sin(x) };\nvar cot = function(x) { return 1/Math.tan(x) };\nvar arcsec = function(x) { return arccos(1/x) };\nvar arccsc = function(x) { return arcsin(1/x) };\nvar arccot = function(x) { return arctan(1/x) };\nvar sinh = function(x) { return (Math.exp(x)-Math.exp(-x))/2 };\nvar cosh = function(x) { return (Math.exp(x)+Math.exp(-x))/2 };\nvar tanh = \n  function(x) { return (Math.exp(x)-Math.exp(-x))/(Math.exp(x)+Math.exp(-x)) };\nvar sech = function(x) { return 1/cosh(x) };\nvar csch = function(x) { return 1/sinh(x) };\nvar coth = function(x) { return 1/tanh(x) };\nvar arcsinh = function(x) { return ln(x+Math.sqrt(x*x+1)) };\nvar arccosh = function(x) { return ln(x+Math.sqrt(x*x-1)) };\nvar arctanh = function(x) { return ln((1+x)/(1-x))/2 };\nvar sech = function(x) { return 1/cosh(x) };\nvar csch = function(x) { return 1/sinh(x) };\nvar coth = function(x) { return 1/tanh(x) };\nvar arcsech = function(x) { return arccosh(1/x) };\nvar arccsch = function(x) { return arcsinh(1/x) };\nvar arccoth = function(x) { return arctanh(1/x) };\nvar sign = function(x) { return (x==0?0:(x<0?-1:1)) };\n\nfunction factorial(x,n) { // Factorial function\n  if (n==null) n=1;\n  if (Math.abs(x-Math.round(x*1000000)/1000000)<1e-15)\n    x = Math.round(x*1000000)/1000000;\n  if (x-Math.floor(x)!=0) return NaN;\n  for (var i=x-n; i>0; i-=n) x*=i;\n  return (x<0?NaN:(x==0?1:x));\n}\n\nfunction C(x,k) {  // Binomial coefficient function\n  var res=1;\n  for (var i=0; i<k; i++) res*=(x-i)/(k-i);\n  return res;\n}\n\nfunction chop(x,n) { // Truncate decimal number to n places after decimal point\n  if (n==null) n=0;\n  return Math.floor(x*Math.pow(10,n))/Math.pow(10,n);\n}\n\nfunction ran(a,b,n) { // Generate random number in [a,b] with n digits after .\n  if (n==null) n=0;\n  return chop((b+Math.pow(10,-n)-a)*Math.random()+a,n);\n}\n\nfunction myCreateElementSVG(t) {\n  if (isIE) return doc.createElement(t);\n  else return doc.createElementNS(\"http://www.w3.org/2000/svg\",t);\n}\n\nfunction getElementsByClass(container, tagName, clsName){\n  var list = new Array(0);\n  var collection = container.getElementsByTagName(tagName);\n  for(var i = 0; i < collection.length; i++)\n    if(collection[i].className.slice(0,clsName.length)==clsName)\n      list[list.length] = collection[i];\n  return list;\n}\n\nfunction showobj(obj) {\n  var st=\"\", i;\n  for (i in obj) \n    st += (obj.getAttribute(i)==null?\"\":\" \"+i+\":\"+obj.getAttribute(i));\n  return st;\n}\n\nfunction findPos(obj) { // top-left corner of obj on HTML page in pixel\n  var curleft = curtop = 0;\n  if (obj.offsetParent) {\n    curleft = obj.offsetLeft\n    curtop = obj.offsetTop\n    while (obj = obj.offsetParent) {\n      curleft += obj.offsetLeft\n      curtop += obj.offsetTop\n//alert(showobj(obj)+[curleft,curtop])\n    }\n  }\n  return [curleft,curtop];\n}\n\nfunction checkSVG(){\n  if (navigator.appName.slice(0,8)==\"Netscape\") \n    if (window['SVGElement']) noSVG = null;\n    else noSVG = true;\n  else if (navigator.appName.slice(0,9)==\"Microsoft\")\n    try {\n      var oSVG=eval(\"new ActiveXObject('Adobe.SVGCtl.3');\");\n        noSVG = null;\n    } catch (e) {\n        noSVG = true;\n    }\n  else if (navigator.appName.slice(0,5)==\"Opera\") // works only for 9.50b1\n    noSVG = null;\n  else noSVG = true;\n//noSVG = true; //uncomment to check\n  if (noSVG && notifyIfNoSVG) {\n    var msg = \"To view the ASCIIsvg images use Internet Explorer + Adobe SVGviewer or Mozilla Firefox 2.0 or later.\"\n    if (alertIfNoSVG)\n      alert(msg);\n    else return msg;\n  }\n}\n\nfunction setText(st,id) { // add text to an existing node with given id\n  var node = document.getElementById(id);\n  if (node!=null)\n    if (node.childNodes.length!=0) node.childNodes[0].nodeValue = st;\n    else node.appendChild(document.createTextNode(st));\n}\n\nfunction getX(evt) { // return mouse x-coord in user coordinate system\n  var svgroot = evt.target.parentNode;\n    pos = findPos(svgroot.parentNode);\n  return (evt.clientX+(isIE?0:window.pageXOffset)-pos[0]-svgroot.getAttribute(\"ox\"))/parseFloat(svgroot.getAttribute(\"xunitlength\"));\n}\n\nfunction getY(evt) { // return mouse y-coord in user coordinate system\n  var svgroot = evt.target.parentNode;\n    pos = findPos(svgroot.parentNode);\n//alert(showobj(svgroot)+svgroot.getAttribute(\"mytop\"))\n  return (svgroot.getAttribute(\"height\")-svgroot.getAttribute(\"oy\")-(evt.clientY+(isIE?0:window.pageYOffset)-pos[1]))/parseFloat(svgroot.getAttribute(\"yunitlength\"));\n}\n\nfunction translateandeval(src) { //modify user input to JavaScript syntax\n  var errstr;\n  // replace plot(f(x),...) with plot(\"f(x)\",...)  \n  src = src.replace(/plot\\(\\x20*([^\\\"f\\[][^\\n\\r;]+?)\\,/g,\"plot\\(\\\"$1\\\",\");\n  src = src.replace(/plot\\(\\x20*([^\\\"f\\[][^\\n\\r;]+)\\)/g,\"plot(\\\"$1\\\")\");\n\n  // replace (expr,expr) by [expr,expr] where expr has no (,) in it\n  src = src.replace(/([=[(,]\\x20*)\\(([-a-z0-9./+*]+?),([-a-z0-9./+*]+?)\\)/g,\"$1[$2,$3]\");\n//alert(src)\n  // insert * between digit and letter e.g. 2x --> 2*x\n  src = src.replace(/([0-9])([a-df-zA-Z]|e^)/g,\"$1*$2\");\n  src = src.replace(/\\)([\\(0-9a-zA-Z])/g,\"\\)*$1\");\n\n  try {\n    with (Math) eval(src);          // here the svgpicture object is created\n  } catch(err) {\n    if (err!=\"wait\") {\n//alert(dsvglocation)\n      if (typeof err==\"object\") \n        errstr = err.name+\" \"+err.message+\" \"+err.number+\" \"+err.description;\n      else errstr = err;\n      alert(errstr+\"\\n\"+src)\n    }\n  }\n}\n\nvar lastSlot = 0;\n\nfunction drawPictures() { // main routine; called after webpage has loaded\n  var src, id, dsvg, nd, node, ht, index, cols, arr, i, node2;\n  var ASbody = document.getElementsByTagName(\"body\")[0];\n  pictures = getElementsByClass(ASbody,\"embed\",\"ASCIIsvg\");\n  var len = pictures.length;\n  if(len==0) return;\n  for (index = lastSlot; index < len+lastSlot; index++) {\n   width = null; height = null; \n   xmin = null; xmax = null; ymin = null; ymax = null;\n   xscl = null; xgrid = null; yscl = null; ygrid = null;\n   initialized = false;\n   picture = pictures[index-lastSlot];  // current picture object\n   src = picture.getAttribute(\"script\"); // get the ASCIIsvg code\n   if (src==null) src = \"\";\n   // insert \"axes()\" if not present  ******** experimental\n   if (!/axes\\b|initPicture/.test(src)) {\n     var i = 0;\n     while (/((yscl|ymax|ymin|xscl|xmax|xmin|\\bwidth|\\bheight)\\s*=\\s*-?\\d*(\\d\\.|\\.\\d|\\d)\\d*\\s*;?)/.test(src.slice(i))) i++;\n     src = (i==0?\"axes(); \"+src: src.slice(0,i)+src.slice(i).replace(/((scl|max|min|idth|eight)\\s*=\\s*-?\\d*(\\d\\.|\\.\\d|\\d)\\d*\\s*;?)/,\"$1\\naxes();\"));\n   }\n   ht = picture.getAttribute(\"height\");\n   if (isIE) {\n     picture.setAttribute(\"wmode\",\"transparent\");\n//alert(\"*\"+picture.getAttribute(\"src\")+dsvglocation);\n//adding d.svg dynamically greates problems in IE...\n//     if (picture.getAttribute(\"src\")==\"\") picture.setAttribute(\"src\",dsvglocation+\"d.svg\");\n   }\n   if (document.getElementById(\"picture\"+(index+1)+\"mml\")==null) {\n     picture.parentNode.style.position = \"relative\";\n     node = createElementXHTML(\"div\");\n     node.style.position = \"absolute\";\n     node.style.top = \"0px\";\n     node.style.left = \"0px\";\n     node.setAttribute(\"id\",\"picture\"+(index+1)+\"mml\");\n     picture.parentNode.insertBefore(node,picture.nextSibling);\n   }\n   if (ht==null) ht =\"\";\n//   if (ht!=\"\") defaultborder = 25;\n   if (ht==\"\" || src==\"\") \n    if (document.getElementById(\"picture\"+(index+1)+\"input\")==null) {\n      node = createElementXHTML(\"textarea\");\n      arr = src.split(\"\\n\");\n      cols = 0;\n      for (i=0;i<arr.length;i++) cols = Math.max(cols,arr[i].length);\n      node.setAttribute(\"rows\",Math.min(10,arr.length)+1);\n      node.setAttribute(\"cols\",Math.max(Math.min(60,cols),20)+5);\n//      node.setAttribute(\"style\",\"display:block\");\n      if (isIE) src = src.replace(/([^\\r])\\n/g,\"$1\\r\");\n      node.appendChild(document.createTextNode(src));\n      if (src.indexOf(\"showcode()\")==-1) node.style.display = \"none\";\n      node.setAttribute(\"id\",\"picture\"+(index+1)+\"input\");\n      picture.parentNode.insertBefore(node,picture.nextSibling);\n      picture.parentNode.insertBefore(createElementXHTML(\"br\"),node);\n      node2 = createElementXHTML(\"button\");\n      node2.setAttribute(\"id\",\"picture\"+(index+1)+\"button\");\n      if (isIE) node2.onclick = function() {updatePicture(this)};\n      else node2.setAttribute(\"onclick\",\"updatePicture(this)\");\n      node2.appendChild(document.createTextNode(\"Update\"));\n      if (src.indexOf(\"showcode()\")==-1) node2.style.display = \"none\";\n      picture.parentNode.insertBefore(node2,node);\n//      picture.parentNode.insertBefore(document.createTextNode(\"ASCII\"),node);\n      picture.parentNode.insertBefore(createElementXHTML(\"br\"),node);\n    } else src = document.getElementById(\"picture\"+(index+1)+\"input\").value;\n    id = picture.getAttribute(\"id\");\n    dsvg = picture.getAttribute(\"src\");\n    if (id == null || id == \"\") {\n      id = \"picture\"+(index+1);\n      picture.setAttribute(\"id\",id);\n    }\n    translateandeval(src);\n  }\n  lastSlot+=len;\n}\n\nfunction setdefaults() { //called before each graph is evaluated\n  strokewidth = defaultstrokewidth;\n  stroke = defaultstroke;\n  strokeopacity = defaultstrokeopacity;\n  strokedasharray = defaultstrokedasharray;\n  fill = defaultfill;\n  fillopacity = defaultfillopacity;\n  fontstyle = defaultfontstyle;\n  fontfamily = defaultfontfamily;\n  fontsize = defaultfontsize;\n  fontweight = defaultfontweight;\n  fontstroke = defaultfontstroke;\n  fontfill = defaultfontfill;\n  marker = defaultmarker;\n  endpoints = defaultendpoints;\n}\n\nfunction switchTo(id) { // used by dynamic code to select appropriate graph\n  if (id==undefined) return;\n  var name = id;\n  if (typeof name!=\"string\") name = id.target.parentNode.getAttribute(\"name\");\n  picture = document.getElementById(name);\n  width = picture.getAttribute(\"width\")-0;\n  height = picture.getAttribute(\"height\")-0;\n  setdefaults();\n  if ((picture.nodeName == \"EMBED\" || picture.nodeName == \"embed\") && isIE) {\n    svgpicture = picture.getSVGDocument().getElementById(\"root\");\n    doc = picture.getSVGDocument();\n  } else {\n    svgpicture = picture;\n    doc = document;\n  }\n  xunitlength = parseFloat(svgpicture.getAttribute(\"xunitlength\"));\n  yunitlength = parseFloat(svgpicture.getAttribute(\"yunitlength\"));\n  xmin = parseFloat(svgpicture.getAttribute(\"xmin\"));\n  xmax = parseFloat(svgpicture.getAttribute(\"xmax\"));\n  ymin = parseFloat(svgpicture.getAttribute(\"ymin\"));\n  ymax = parseFloat(svgpicture.getAttribute(\"ymax\"));\n  origin = [svgpicture.getAttribute(\"ox\")-0,svgpicture.getAttribute(\"oy\")-0];\n}\n\nfunction updatePicture(obj) {\n  var node, src, id, top, left;\n  if (typeof obj==\"object\") id = obj.id.slice(0,-6);\n  else id = (typeof obj==\"string\"?obj:\"picture\"+(obj+1));\n  src = document.getElementById(id+\"input\").value;\n  xmin = null; xmax = null; ymin = null; ymax = null;\n  xscl = null; xgrid = null; yscl = null; ygrid = null;\n  initialized = false;\n  picture = document.getElementById(id);\n  translateandeval(src)\n}\n\nfunction changepicturesize(evt,factor) {\n  var obj = evt.target;\n  var name = obj.parentNode.getAttribute(\"name\");\n  var pic = document.getElementById(name);\n  var src = document.getElementById(name+\"input\").value;\n  if (!/height/.test(src)) src = \"height=0; \"+src;\n  if (!/width/.test(src)) src = \"width=0; \"+src;\n  src = src.replace(/width\\s*=\\s*\\d+/,\"width=\"+(factor*(pic.getAttribute(\"width\")-0)));\n  src = src.replace(/height\\s*=\\s*\\d+/,\"height=\"+(factor*(pic.getAttribute(\"height\")-0)));\n  document.getElementById(name+\"input\").value = src;\n//alert(getKey(evt.keycode))\n  updatePicture(name);\n}\n\nfunction zoom(evt,factor) {\n  switchTo(evt);\n  var obj = evt.target;\n  var name = obj.parentNode.getAttribute(\"name\");\n  var pic = document.getElementById(name);\n  var src = document.getElementById(name+\"input\").value;\n  var xlen = (xmax-xmin)/2;\n  var ylen = (ymax-ymin)/2;\n  var xcen = getX(evt), ycen = getY(evt);\n  if (!/ymax/.test(src)) src = \"ymax=0; \"+src;\n  if (!/ymin/.test(src)) src = \"ymin=0; \"+src;\n  if (!/xmax/.test(src)) src = \"xmax=0; \"+src;\n  if (!/xmin/.test(src)) src = \"xmin=0; \"+src;\n  src = src.replace(/xmin\\s*=\\s*[-\\d.e]+/,\"xmin=\"+(xcen-factor*xlen));\n  src = src.replace(/xmax\\s*=\\s*[-\\d.e]+/,\"xmax=\"+(xcen+factor*xlen));\n  src = src.replace(/ymin\\s*=\\s*[-\\d.e]+/,\"ymin=\"+(ycen-factor*ylen));\n  src = src.replace(/ymax\\s*=\\s*[-\\d.e]+/,\"ymax=\"+(ycen+factor*ylen));\n  document.getElementById(name+\"input\").value = src;\n  updatePicture(name);\n}\n\nvar sinceFirstClick = 0; // ondblclick simulation from \nvar dblClkTimer;         // http://www.enja.org/david/?cat=13 Thanks!\nfunction timer() {\n  if(sinceFirstClick<60) {\n    sinceFirstClick++;\n    setTimeout(\"timer()\",10);\n  } else {\n    clearTimeout(dblClkTimer);\n    dblClkTimer = \"\";\n  }\n}\nfunction mClick(evt) {\n  if(sinceFirstClick!=0) {\n    if(sinceFirstClick <= 40) {\n      if (evt.shiftKey) {\n        if (evt.altKey) changepicturesize(evt,2);\n        else zoom(evt,.5);\n      } else if (evt.altKey) zoom(evt,2);//changepicturesize(evt,.5);\n      else showHideCode(evt);             // do this on dblclick\n      clearTimeout(dblClkTimer);\n      dblClkTimer = \"\";\n    } else {\n      clearTimeout(dblClkTimer);\n      sinceFirstClick = 0;\n      dblClkTimer = setTimeout(\"timer()\",10);\n    }\t      \n  } else {\n    sinceFirstClick = 0;\n    dblClkTimer = setTimeout(\"timer()\",10);\n  }\n}\n\nfunction showHideCode(evt) { // called by onclick event\n//  if (evt.getDetail()==2) {//getDetail unfortunately not in Firefox\n  var obj=evt.target;\n  var name = obj.parentNode.getAttribute(\"name\");\n  var node = document.getElementById(name+\"input\");\n  node.style.display = (node.style.display == \"none\"?\"\":\"none\");\n  var node = document.getElementById(name+\"button\");\n  node.style.display = (node.style.display == \"none\"?\"\":\"none\");\n//  }\n}\n\nfunction showcode() {} // do nothing\n\nfunction setBorder(x) { border = x } //deprecate\n\nfunction initPicture(x_min,x_max,y_min,y_max) { // set up the graph\n// usually called by axes() or noaxes(), but can be used directly\n if (!initialized) {\n  setdefaults();\n  initialized = true;\n  if (x_min!=null) xmin = x_min;\n  if (x_max!=null) xmax = x_max;\n  if (y_min!=null) ymin = y_min;\n  if (y_max!=null) ymax = y_max;\n  if (xmin==null) xmin = defaultxmin;\n  if (xmax==null) xmax = defaultxmax;\n if (typeof xmin != \"number\" || typeof xmax != \"number\" || xmin >= xmax) \n   alert(\"Picture requires at least two numbers: xmin < xmax\");\n else if (y_max != null && (typeof y_min != \"number\" || \n          typeof y_max != \"number\" || y_min >= y_max))\n   alert(\"initPicture(xmin,xmax,ymin,ymax) requires numbers ymin < ymax\");\n else {\n  if (width==null) {\n    width = picture.getAttribute(\"width\");\n    if (width==null || width==\"\") width=defaultwidth;\n  }\n  picture.setAttribute(\"width\",width);\n  if (height==null) { \n    height = picture.getAttribute(\"height\");\n    if (height==null || height==\"\") height=defaultheight;\n  }\n  picture.setAttribute(\"height\",height);\n  xunitlength = (width-2*border)/(xmax-xmin);\n  yunitlength = xunitlength;\n//alert(xmin+\" \"+xmax+\" \"+ymin+\" \"+ymax)\n  if (ymin==null) {\n    origin = [-xmin*xunitlength+border,height/2];\n    ymin = -(height-2*border)/(2*yunitlength);\n    ymax = -ymin;\n  } else {\n    if (ymax!=null) yunitlength = (height-2*border)/(ymax-ymin);\n    else ymax = (height-2*border)/yunitlength + ymin;\n    origin = [-xmin*xunitlength+border,-ymin*yunitlength+border];\n  }\n  if (isIE) {\n    if (picture.FULLSCREEN==undefined) {\n      setTimeout('drawPictures()',50);\n      throw \"wait\";\n    }\n    svgpicture = picture.getSVGDocument().getElementById(\"root\");\n    if (svgpicture==null) {\n      setTimeout('drawPictures()',50);\n      throw \"wait\";\n    }\n    svgpicture = picture.getSVGDocument().getElementById(\"root\");\n    while (svgpicture.childNodes.length>0) \n      svgpicture.removeChild(svgpicture.lastChild); \n    svgpicture.setAttribute(\"width\",width);\n    svgpicture.setAttribute(\"height\",height);\n    svgpicture.setAttribute(\"name\",picture.getAttribute(\"id\"));\n    doc = picture.getSVGDocument();\n  } else {\n    var qnode = document.createElementNS(\"http://www.w3.org/2000/svg\",\"svg\");\n    qnode.setAttribute(\"id\",picture.getAttribute(\"id\"));\n    qnode.setAttribute(\"name\",picture.getAttribute(\"id\"));\n//    qnode.setAttribute(\"style\",\"display:inline\");\n    qnode.setAttribute(\"width\",picture.getAttribute(\"width\"));\n    qnode.setAttribute(\"height\",picture.getAttribute(\"height\"));\n    picturepos = findPos(picture);\n//  qnode.setAttribute(\"xmlns:xlink\",\"http://www.w3.org/1999/xlink\");\n    if (picture.parentNode!=null) {\n      picture.parentNode.replaceChild(qnode,picture);\n    } else {\n      svgpicture.parentNode.replaceChild(qnode,svgpicture);\n    }\n    svgpicture = qnode;\n    doc = document;\n  }\n  var nd = document.getElementById(picture.getAttribute(\"id\")+\"mml\");\n  if (nd!=null) // clear out MathML layer\n    while (nd.childNodes.length>0) nd.removeChild(nd.lastChild); \n  svgpicture.setAttribute(\"xunitlength\",xunitlength);\n  svgpicture.setAttribute(\"yunitlength\",yunitlength);\n  svgpicture.setAttribute(\"xmin\",xmin);\n  svgpicture.setAttribute(\"xmax\",xmax);\n  svgpicture.setAttribute(\"ymin\",ymin);\n  svgpicture.setAttribute(\"ymax\",ymax);\n  svgpicture.setAttribute(\"ox\",origin[0]);\n  svgpicture.setAttribute(\"oy\",origin[1]);\n  var node = myCreateElementSVG(\"rect\");\n  node.setAttribute(\"x\",\"0\");\n  node.setAttribute(\"y\",\"0\");\n  node.setAttribute(\"width\",width);\n  node.setAttribute(\"height\",height);\n  node.setAttribute(\"style\",backgroundstyle);\n  svgpicture.appendChild(node);\n  svgpicture.setAttribute(\"onmousemove\",\"displayCoord(evt)\");\n  svgpicture.setAttribute(\"onmouseout\",\"removeCoord(evt)\");\n  svgpicture.setAttribute(\"onclick\",\"mClick(evt)\");\n  node = myCreateElementSVG(\"text\"); // used for displayCoord\n  node.appendChild(doc.createTextNode(\" \"));\n  node.setAttribute(\"id\",\"coords\");\n  svgpicture.appendChild(node);\n  node = myCreateElementSVG(\"text\"); // used for text display\n  node.appendChild(doc.createTextNode(\" \"));\n  node.setAttribute(\"id\",\"coords\");\n  svgpicture.appendChild(node);\n  border = defaultborder;\n }\n }\n}\n\n//////////////////////////user graphics commands start/////////////////////////\n\nfunction line(p,q,id,endpts) { // segment connecting points p,q (coordinates in units)\n  var node;\n  if (id!=null) node = doc.getElementById(id);\n  if (node==null) {\n    node = myCreateElementSVG(\"path\");\n    node.setAttribute(\"id\", id);\n    svgpicture.appendChild(node);\n  }\n  node.setAttribute(\"d\",\"M\"+(p[0]*xunitlength+origin[0])+\",\"+\n    (height-p[1]*yunitlength-origin[1])+\" \"+\n    (q[0]*xunitlength+origin[0])+\",\"+(height-q[1]*yunitlength-origin[1]));\n  node.setAttribute(\"stroke-width\", strokewidth);\n  if (strokedasharray!=null) \n    node.setAttribute(\"stroke-dasharray\", strokedasharray);\n  node.setAttribute(\"stroke\", stroke);\n  node.setAttribute(\"fill\", fill);\n  node.setAttribute(\"stroke-opacity\", strokeopacity);\n  node.setAttribute(\"fill-opacity\", fillopacity);\n  if (marker==\"dot\" || marker==\"arrowdot\") {\n    ASdot(p,markersize,markerstroke,markerfill);\n    if (marker==\"arrowdot\") arrowhead(p,q);\n    ASdot(q,markersize,markerstroke,markerfill);\n  } else if (marker==\"arrow\") arrowhead(p,q);\n  if (endpts==null && endpoints!=\"\") endpts = endpoints;\n  if (endpts!=null) {\n    if (endpts.indexOf(\"<-\") != -1) arrowhead(q,p);\n    if (endpts.indexOf(\"o-\") != -1) dot(p, \"open\");\n    if (endpts.indexOf(\"*-\") != -1) dot(p, \"closed\");\n    if (endpts.indexOf(\"->\") != -1) arrowhead(p,q);\n    if (endpts.indexOf(\"-o\") != -1) dot(q, \"open\");\n    if (endpts.indexOf(\"-*\") != -1) dot(q, \"closed\");\n  }\n}\n\nfunction path(plist,id,c,endpts) {\n  if (c==null) c=\"\";\n  var node, st, i;\n  if (id!=null) node = doc.getElementById(id);\n  if (node==null) {\n    node = myCreateElementSVG(\"path\");\n    node.setAttribute(\"id\", id);\n    svgpicture.appendChild(node);\n  }\n  if (typeof plist == \"string\") st = plist;\n  else {\n    st = \"M\";\n    st += (plist[0][0]*xunitlength+origin[0])+\",\"+\n          (height-plist[0][1]*yunitlength-origin[1])+\" \"+c;\n    for (i=1; i<plist.length; i++)\n      st += (plist[i][0]*xunitlength+origin[0])+\",\"+\n            (height-plist[i][1]*yunitlength-origin[1])+\" \";\n  }\n  node.setAttribute(\"d\", st);\n  node.setAttribute(\"stroke-width\", strokewidth);\n  if (strokedasharray!=null) \n    node.setAttribute(\"stroke-dasharray\", strokedasharray);\n  node.setAttribute(\"stroke\", stroke);\n  node.setAttribute(\"fill\", fill);\n  node.setAttribute(\"stroke-opacity\", strokeopacity);\n  node.setAttribute(\"fill-opacity\", fillopacity);\n  if (marker==\"dot\" || marker==\"arrowdot\")\n    for (i=0; i<plist.length; i++)\n      if (c!=\"C\" && c!=\"T\" || i!=1 && i!=2)\n        ASdot(plist[i],markersize,markerstroke,markerfill);\n  if (endpts==null && endpoints!=\"\") endpts = endpoints;\n  if (endpts!=null) {\n    if (endpts.indexOf(\"<-\") != -1) arrowhead(plist[1],plist[0]);\n    if (endpts.indexOf(\"o-\") != -1) dot(plist[0], \"open\");\n    if (endpts.indexOf(\"*-\") != -1) dot(plist[0], \"closed\");\n    if (endpts.indexOf(\"->\") != -1) arrowhead(plist[plist.length-2],plist[plist.length-1]);\n    if (endpts.indexOf(\"-o\") != -1) dot(plist[plist.length-1], \"open\");\n    if (endpts.indexOf(\"-*\") != -1) dot(plist[plist.length-1], \"closed\");\n  }\n}\n\nfunction curve(plist,id,endpts) {\n  path(plist,id,\"T\",endpts);\n}\n\nfunction vector(p,q,id) {\n  line(p,q,id,\"\",\"->\");\n}\n\nfunction circle(center,radius,id) { // coordinates in units\n  var node;\n  if (id!=null) node = doc.getElementById(id);\n  if (node==null) {\n    node = myCreateElementSVG(\"circle\");\n    node.setAttribute(\"id\", id);\n    svgpicture.appendChild(node);\n  }\n  node.setAttribute(\"cx\",center[0]*xunitlength+origin[0]);\n  node.setAttribute(\"cy\",height-center[1]*yunitlength-origin[1]);\n  node.setAttribute(\"r\",radius*xunitlength);\n  node.setAttribute(\"stroke-width\", strokewidth);\n  node.setAttribute(\"stroke\", stroke);\n  node.setAttribute(\"fill\", fill);\n  node.setAttribute(\"stroke-opacity\", strokeopacity);\n  node.setAttribute(\"fill-opacity\", fillopacity);\n}\n\nfunction loop(p,d,id) { \n// d is a direction vector e.g. [1,0] means loop starts in that direction\n  if (d==null) d=[1,0];\n  path([p,[p[0]+d[0],p[1]+d[1]],[p[0]-d[1],p[1]+d[0]],p],id,\"C\");\n  if (marker==\"arrow\" || marker==\"arrowdot\") \n    arrowhead([p[0]+Math.cos(1.4)*d[0]-Math.sin(1.4)*d[1],\n               p[1]+Math.sin(1.4)*d[0]+Math.cos(1.4)*d[1]],p);\n}\n\nfunction arc(start,end,radius,id,largearc) { // coordinates in units\n  var node, v;\n//alert([fill, stroke, origin, xunitlength, yunitlength, height])\n  if (id!=null) node = doc.getElementById(id);\n  if (largearc==null) largearc=0;\n  if (radius==null) {\n    v=[end[0]-start[0],end[1]-start[1]];\n    radius = Math.sqrt(v[0]*v[0]+v[1]*v[1]);\n  }\n  if (node==null) {\n    node = myCreateElementSVG(\"path\");\n    node.setAttribute(\"id\", id);\n    svgpicture.appendChild(node);\n  }\n  node.setAttribute(\"d\",\"M\"+(start[0]*xunitlength+origin[0])+\",\"+\n    (height-start[1]*yunitlength-origin[1])+\" A\"+radius*xunitlength+\",\"+\n     radius*yunitlength+\" 0 \"+largearc+\",0 \"+(end[0]*xunitlength+origin[0])+\",\"+\n    (height-end[1]*yunitlength-origin[1]));\n  node.setAttribute(\"stroke-width\", strokewidth);\n  node.setAttribute(\"stroke\", stroke);\n  node.setAttribute(\"fill\", fill);\n  node.setAttribute(\"stroke-opacity\", strokeopacity);\n  node.setAttribute(\"fill-opacity\", fillopacity);\n  if (marker==\"arrow\" || marker==\"arrowdot\") {\n    u = [(end[1]-start[1])/4,(start[0]-end[0])/4];\n    v = [(end[0]-start[0])/2,(end[1]-start[1])/2];\n//alert([u,v])\n    v = [start[0]+v[0]+u[0],start[1]+v[1]+u[1]];\n  } else v=[start[0],start[1]];\n  if (marker==\"dot\" || marker==\"arrowdot\") {\n    ASdot(start,markersize,markerstroke,markerfill);\n    if (marker==\"arrowdot\") arrowhead(v,end);\n    ASdot(end,markersize,markerstroke,markerfill);\n  } else if (marker==\"arrow\") arrowhead(v,end);\n}\n\nfunction sector(center,start,end,id) { // center,start,end should be isoceles\n  var rx = start[0]-center[0], ry = start[1]-center[1];\n  arc(start,end,Math.sqrt(rx*rx+ry*ry),id+\"arc\");\n  path([end,center,start],id+\"path\");\n}\n\nfunction ellipse(center,rx,ry,id) { // coordinates in units\n  var node;\n  if (id!=null) node = doc.getElementById(id);\n  if (node==null) {\n    node = myCreateElementSVG(\"ellipse\");\n    node.setAttribute(\"id\", id);\n    svgpicture.appendChild(node);\n  }\n  node.setAttribute(\"cx\",center[0]*xunitlength+origin[0]);\n  node.setAttribute(\"cy\",height-center[1]*yunitlength-origin[1]);\n  node.setAttribute(\"rx\",rx*xunitlength);\n  node.setAttribute(\"ry\",ry*yunitlength);\n  node.setAttribute(\"stroke-width\", strokewidth);\n  node.setAttribute(\"stroke\", stroke);\n  node.setAttribute(\"fill\", fill);\n  node.setAttribute(\"stroke-opacity\", strokeopacity);\n  node.setAttribute(\"fill-opacity\", fillopacity);\n}\n\nfunction triangle(p,q,r,id) {\n  path([p,q,r,p],id)\n}\n\nfunction rect(p,q,id,rx,ry) { // opposite corners in units, rounded by radii\n  var node;\n  if (id!=null) node = doc.getElementById(id);\n  if (node==null) {\n    node = myCreateElementSVG(\"rect\");\n    node.setAttribute(\"id\", id);\n    svgpicture.appendChild(node);\n  }\n  node.setAttribute(\"x\",p[0]*xunitlength+origin[0]);\n  node.setAttribute(\"y\",height-q[1]*yunitlength-origin[1]);\n  node.setAttribute(\"width\",(q[0]-p[0])*xunitlength);\n  node.setAttribute(\"height\",(q[1]-p[1])*yunitlength);\n  if (rx!=null) node.setAttribute(\"rx\",rx*xunitlength);\n  if (ry!=null) node.setAttribute(\"ry\",ry*yunitlength);\n  node.setAttribute(\"stroke-width\", strokewidth);\n  node.setAttribute(\"stroke\", stroke);\n  node.setAttribute(\"fill\", fill);\n  node.setAttribute(\"stroke-opacity\", strokeopacity);\n  node.setAttribute(\"fill-opacity\", fillopacity);\n}\n\nfunction text(p,st,pos,id,fontsty) {\n  var dnode, node, dx = 0, dy = fontsize/3, str = st.toString();\n  if (/(`|\\$)/.test(str)) {  // layer for ASCIIMathML and LaTeXMathML\n    dnode = document.getElementById(svgpicture.getAttribute(\"name\")+\"mml\");\n    if (dnode!=null) {\n      if (id!=null) node = document.getElementById(id);\n      if (node==null) {\n//alert(dnode.childNodes.length)\n        node = createElementXHTML(\"div\");\n        node.setAttribute(\"id\", id);\n        node.style.position = \"absolute\";\n        dnode.appendChild(node);\n      }\n      while (node.childNodes.length>0) node.removeChild(node.lastChild); \n      node.appendChild(document.createTextNode(str));\n      if (/`/.test(str)) AMprocessNode(node); else LMprocessNode(node);\n      dx = -node.offsetWidth/2;\n      dy = -node.offsetHeight/2;\n      if (pos!=null) {\n        if (/above/.test(pos)) dy = -node.offsetHeight;\n        if (/below/.test(pos)) dy = 0;\n        if (/right/.test(pos)) dx = 0;\n        if ( /left/.test(pos)) dx = -node.offsetWidth;\n      }\n      node.style.left = \"\"+(p[0]*xunitlength+origin[0]+dx)+\"px\";\n      node.style.top = \"\"+(height-p[1]*yunitlength-origin[1]+dy)+\"px\";\n    }\n    return p;\n  }\n  var textanchor = \"middle\";  // regular text goes into SVG\n  if (pos!=null) {\n    if (/above/.test(pos)) dy = -fontsize/2;\n    if (/below/.test(pos)) dy = fontsize-0;\n    if (/right/.test(pos)) {textanchor = \"start\"; dx = fontsize/4;}\n    if ( /left/.test(pos)) {textanchor = \"end\";  dx = -fontsize/4;}\n  }\n  if (id!=null) node = doc.getElementById(id);\n  if (node==null) {\n    node = myCreateElementSVG(\"text\");\n    node.setAttribute(\"id\", id);\n    svgpicture.appendChild(node);\n    node.appendChild(doc.createTextNode(str));\n  }\n  while (node.childNodes.length>1) node.removeChild(node.lastChild); \n  node.lastChild.nodeValue = \"\\xA0\"+str+\"\\xA0\";\n  node.setAttribute(\"x\",p[0]*xunitlength+origin[0]+dx);\n  node.setAttribute(\"y\",height-p[1]*yunitlength-origin[1]+dy);\n  node.setAttribute(\"font-style\",(fontsty!=null?fontsty:\n    (str.search(/^[a-zA-Z]$/)!=-1?\"italic\":fontstyle)));\n  node.setAttribute(\"font-family\",fontfamily);\n  node.setAttribute(\"font-size\",fontsize);\n  node.setAttribute(\"font-weight\",fontweight);\n  node.setAttribute(\"text-anchor\",textanchor);\n  if (fontstroke!=\"none\") node.setAttribute(\"stroke\",fontstroke);\n  if (fontfill!=\"none\") node.setAttribute(\"fill\",fontfill);\n  return p;\n}\n\nfunction mtext(p,st,pos,fontsty,fontsz) { // method for updating text on an svg\n// \"this\" is the text object or the svgpicture object\n  var textanchor = \"middle\";\n  var dx = 0; var dy = fontsize/3;\n  if (pos!=null) {\n    if (pos.slice(0,5)==\"above\") dy = -fontsize/2;\n    if (pos.slice(0,5)==\"below\") dy = fontsize-0;\n    if (pos.slice(0,5)==\"right\" || pos.slice(5,10)==\"right\") {\n      textanchor = \"start\";\n      dx = fontsize/2;\n    }\n    if (pos.slice(0,4)==\"left\" || pos.slice(5,9)==\"left\") {\n      textanchor = \"end\";\n      dx = -fontsize/2;\n    }\n  }\n  var node = this;\n  if (this.nodeName==\"svg\") {\n    node = myCreateElementSVG(\"text\");\n    this.appendChild(node);\n    node.appendChild(doc.createTextNode(st));\n  }\n  node.lastChild.nodeValue = st;\n  node.setAttribute(\"x\",p[0]+dx);\n  node.setAttribute(\"y\",p[1]+dy);\n  node.setAttribute(\"font-style\",(fontsty!=null?fontsty:fontstyle));\n  node.setAttribute(\"font-family\",fontfamily);\n  node.setAttribute(\"font-size\",(fontsz!=null?fontsz:fontsize));\n  node.setAttribute(\"font-weight\",fontweight);\n  node.setAttribute(\"text-anchor\",textanchor);\n  if (fontstroke!=\"none\") node.setAttribute(\"stroke\",fontstroke);\n  if (fontfill!=\"none\") node.setAttribute(\"fill\",fontfill);\n}\n\nfunction image(imgurl,p,w,h,id) { // not working yet\n  var node;\n  if (id!=null) node = doc.getElementById(id);\n  if (node==null) {\n    node = myCreateElementSVG(\"image\");\n    node.setAttribute(\"id\", id);\n    svgpicture.appendChild(node);\n  }\n  node.setAttribute(\"x\",p[0]*xunitlength+origin[0]);\n  node.setAttribute(\"y\",height-p[1]*yunitlength-origin[1]);\n  node.setAttribute(\"width\",w);\n  node.setAttribute(\"height\",h);\n  node.setAttribute(\"xlink:href\", imgurl);\n}\n\nfunction ASdot(center,radius,s,f) { // coordinates in units, radius in pixel\n  if (s==null) s = stroke; if (f==null) f = fill;\n  var node = myCreateElementSVG(\"circle\");\n  node.setAttribute(\"cx\",center[0]*xunitlength+origin[0]);\n  node.setAttribute(\"cy\",height-center[1]*yunitlength-origin[1]);\n  node.setAttribute(\"r\",radius);\n  node.setAttribute(\"stroke-width\", strokewidth);\n  node.setAttribute(\"stroke\", s);\n  node.setAttribute(\"fill\", f);\n  svgpicture.appendChild(node);\n}\n\nfunction dot(center, typ, label, pos, id) {\n  var node;\n  var cx = center[0]*xunitlength+origin[0];\n  var cy = height-center[1]*yunitlength-origin[1];\n  if (id!=null) node = doc.getElementById(id);\n  if (typ==\"+\" || typ==\"-\" || typ==\"|\") {\n    if (node==null) {\n      node = myCreateElementSVG(\"path\");\n      node.setAttribute(\"id\", id);\n      svgpicture.appendChild(node);\n    }\n    if (typ==\"+\") {\n      node.setAttribute(\"d\",\n        \" M \"+(cx-ticklength)+\" \"+cy+\" L \"+(cx+ticklength)+\" \"+cy+\n        \" M \"+cx+\" \"+(cy-ticklength)+\" L \"+cx+\" \"+(cy+ticklength));\n      node.setAttribute(\"stroke-width\", .5);\n      node.setAttribute(\"stroke\", axesstroke);\n    } else {\n      if (typ==\"-\") node.setAttribute(\"d\",\n        \" M \"+(cx-ticklength)+\" \"+cy+\" L \"+(cx+ticklength)+\" \"+cy);\n      else node.setAttribute(\"d\",\n        \" M \"+cx+\" \"+(cy-ticklength)+\" L \"+cx+\" \"+(cy+ticklength));\n      node.setAttribute(\"stroke-width\", strokewidth);\n      node.setAttribute(\"stroke\", stroke);\n    }\n  } else {\n    if (node==null) {\n      node = myCreateElementSVG(\"circle\");\n      node.setAttribute(\"id\", id);\n      svgpicture.appendChild(node);\n    }\n    node.setAttribute(\"cx\",cx);\n    node.setAttribute(\"cy\",cy);\n    node.setAttribute(\"r\",dotradius);\n    node.setAttribute(\"stroke-width\", strokewidth);\n    node.setAttribute(\"stroke\", stroke);\n    node.setAttribute(\"fill\", (typ==\"open\"?\"white\":\n                              (typ==\"closed\"?stroke:markerfill)));\n  }\n  if (label!=null) \n    text(center,label,(pos==null?\"below\":pos),(id==null?id:id+\"label\"))\n}\n\npoint = dot; //alternative name\n\nfunction arrowhead(p,q) { // draw arrowhead at q (in units) add size param\n  var up;\n  var v = [p[0]*xunitlength+origin[0],height-p[1]*yunitlength-origin[1]];\n  var w = [q[0]*xunitlength+origin[0],height-q[1]*yunitlength-origin[1]];\n  var u = [w[0]-v[0],w[1]-v[1]];\n  var d = Math.sqrt(u[0]*u[0]+u[1]*u[1]);\n  if (d > 0.00000001) {\n    u = [u[0]/d, u[1]/d];\n    up = [-u[1],u[0]];\n    var node = myCreateElementSVG(\"path\");\n    node.setAttribute(\"d\",\"M \"+(w[0]-15*u[0]-4*up[0])+\" \"+\n      (w[1]-15*u[1]-4*up[1])+\" L \"+(w[0]-3*u[0])+\" \"+(w[1]-3*u[1])+\" L \"+\n      (w[0]-15*u[0]+4*up[0])+\" \"+(w[1]-15*u[1]+4*up[1])+\" z\");\n    node.setAttribute(\"stroke-width\", markerstrokewidth);\n    node.setAttribute(\"stroke\", stroke); /* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n    node.setAttribute(\"fill\", stroke); /* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */\n    node.setAttribute(\"stroke-opacity\", strokeopacity);\n    node.setAttribute(\"fill-opacity\", fillopacity);\n    svgpicture.appendChild(node);    \n  }\n}\n\nfunction chopZ(st) {\n  var k = st.indexOf(\".\");\n  if (k==-1) return st;\n  for (var i=st.length-1; i>k && st.charAt(i)==\"0\"; i--);\n  if (i==k) i--;\n  return st.slice(0,i+1);\n}\n\nfunction grid(dx,dy) { // for backward compatibility\n  axes(dx,dy,null,dx,dy)\n}\n\nfunction noaxes() {\n  if (!initialized) initPicture();\n}\n\nfunction axes(dx,dy,labels,gdx,gdy) {\n//xscl=x is equivalent to xtick=x; xgrid=x; labels=true;\n  var x, y, ldx, ldy, lx, ly, lxp, lyp, pnode, st;\n  if (!initialized) initPicture();\n  if (typeof dx==\"string\") { labels = dx; dx = null; }\n  if (typeof dy==\"string\") { gdx = dy; dy = null; }\n  if (xscl!=null) {dx = xscl; gdx = xscl; labels = dx}\n  if (yscl!=null) {dy = yscl; gdy = yscl}\n  if (xtick!=null) {dx = xtick}\n  if (ytick!=null) {dy = ytick}\n  dx = (dx==null?xunitlength:dx*xunitlength);\n  dy = (dy==null?dx:dy*yunitlength);\n  fontsize = Math.min(dx/2,dy/2,16); //alert(fontsize)\n  ticklength = fontsize/4;\n  if (xgrid!=null) gdx = xgrid;\n  if (ygrid!=null) gdy = ygrid;\n  if (gdx!=null) {\n    gdx = (typeof gdx==\"string\"?dx:gdx*xunitlength);\n    gdy = (gdy==null?dy:gdy*yunitlength);\n    pnode = myCreateElementSVG(\"path\");\n    st=\"\";\n    for (x = origin[0]; x<width; x = x+gdx)\n      st += \" M\"+x+\",0\"+\" \"+x+\",\"+height;\n    for (x = origin[0]-gdx; x>0; x = x-gdx)\n      st += \" M\"+x+\",0\"+\" \"+x+\",\"+height;\n    for (y = height-origin[1]; y<height; y = y+gdy)\n      st += \" M0,\"+y+\" \"+width+\",\"+y;\n    for (y = height-origin[1]-gdy; y>0; y = y-gdy)\n      st += \" M0,\"+y+\" \"+width+\",\"+y;\n    pnode.setAttribute(\"d\",st);\n    pnode.setAttribute(\"stroke-width\", .5);\n    pnode.setAttribute(\"stroke\", gridstroke);\n    pnode.setAttribute(\"fill\", fill);\n    svgpicture.appendChild(pnode);\n  }\n  pnode = myCreateElementSVG(\"path\");\n  st=\"M0,\"+(height-origin[1])+\" \"+width+\",\"+\n    (height-origin[1])+\" M\"+origin[0]+\",0 \"+origin[0]+\",\"+height;\n  for (x = origin[0]+dx; x<width; x = x+dx)\n    st += \" M\"+x+\",\"+(height-origin[1]+ticklength)+\" \"+x+\",\"+\n           (height-origin[1]-ticklength);\n  for (x = origin[0]-dx; x>0; x = x-dx)\n    st += \" M\"+x+\",\"+(height-origin[1]+ticklength)+\" \"+x+\",\"+\n           (height-origin[1]-ticklength);\n  for (y = height-origin[1]+dy; y<height; y = y+dy)\n    st += \" M\"+(origin[0]+ticklength)+\",\"+y+\" \"+(origin[0]-ticklength)+\",\"+y;\n  for (y = height-origin[1]-dy; y>0; y = y-dy)\n    st += \" M\"+(origin[0]+ticklength)+\",\"+y+\" \"+(origin[0]-ticklength)+\",\"+y;\n  if (labels!=null) with (Math) {\n    ldx = dx/xunitlength;\n    ldy = dy/yunitlength;\n    lx = (xmin>0 || xmax<0?xmin:0);\n    ly = (ymin>0 || ymax<0?ymin:0);\n    lxp = (ly==0?\"below\":\"above\");\n    lyp = (lx==0?\"left\":\"right\");\n    var ddx = floor(1.1-log(ldx)/log(10))+1;\n    var ddy = floor(1.1-log(ldy)/log(10))+1;\n    for (x = ldx; x<=xmax; x = x+ldx)\n      text([x,ly],chopZ(x.toFixed(ddx)),lxp);\n    for (x = -ldx; xmin<=x; x = x-ldx)\n      text([x,ly],chopZ(x.toFixed(ddx)),lxp);\n    for (y = ldy; y<=ymax; y = y+ldy)\n      text([lx,y],chopZ(y.toFixed(ddy)),lyp);\n    for (y = -ldy; ymin<=y; y = y-ldy)\n      text([lx,y],chopZ(y.toFixed(ddy)),lyp);\n  }\n  fontsize = defaultfontsize;\n  pnode.setAttribute(\"d\",st);\n  pnode.setAttribute(\"stroke-width\", .5);\n  pnode.setAttribute(\"stroke\", axesstroke);\n  pnode.setAttribute(\"fill\", fill);\n  pnode.setAttribute(\"stroke-opacity\", strokeopacity);\n  pnode.setAttribute(\"fill-opacity\", fillopacity);\n  svgpicture.appendChild(pnode);\n}\n\nfunction mathjs(st) {\n  //translate a math formula to js function notation\n  // a^b --> pow(a,b)\n  // na --> n*a\n  // (...)d --> (...)*d\n  // n! --> factorial(n)\n  // sin^-1 --> arcsin etc.\n  //while ^ in string, find term on left and right\n  //slice and concat new formula string\n  st = st.replace(/\\s/g,\"\");\n  if (st.indexOf(\"^-1\")!=-1) {\n    st = st.replace(/sin\\^-1/g,\"arcsin\");\n    st = st.replace(/cos\\^-1/g,\"arccos\");\n    st = st.replace(/tan\\^-1/g,\"arctan\");\n    st = st.replace(/sec\\^-1/g,\"arcsec\");\n    st = st.replace(/csc\\^-1/g,\"arccsc\");\n    st = st.replace(/cot\\^-1/g,\"arccot\");\n    st = st.replace(/sinh\\^-1/g,\"arcsinh\");\n    st = st.replace(/cosh\\^-1/g,\"arccosh\");\n    st = st.replace(/tanh\\^-1/g,\"arctanh\");\n    st = st.replace(/sech\\^-1/g,\"arcsech\");\n    st = st.replace(/csch\\^-1/g,\"arccsch\");\n    st = st.replace(/coth\\^-1/g,\"arccoth\");\n  }\n  st = st.replace(/^e$/g,\"(Math.E)\");\n  st = st.replace(/^e([^a-zA-Z])/g,\"(Math.E)$1\");\n  st = st.replace(/([^a-zA-Z])e/g,\"$1(Math.E)\");\n//  st = st.replace(/([^a-zA-Z])e([^a-zA-Z])/g,\"$1(Math.E)$2\");\n  st = st.replace(/([0-9])([\\(a-zA-Z])/g,\"$1*$2\");\n  st = st.replace(/\\)([\\(0-9a-zA-Z])/g,\"\\)*$1\");\n  var i,j,k, ch, nested;\n  while ((i=st.indexOf(\"^\"))!=-1) {\n    //find left argument\n    if (i==0) return \"Error: missing argument\";\n    j = i-1;\n    ch = st.charAt(j);\n    if (ch>=\"0\" && ch<=\"9\") {// look for (decimal) number\n      j--;\n      while (j>=0 && (ch=st.charAt(j))>=\"0\" && ch<=\"9\") j--;\n      if (ch==\".\") {\n        j--;\n        while (j>=0 && (ch=st.charAt(j))>=\"0\" && ch<=\"9\") j--;\n      }\n    } else if (ch==\")\") {// look for matching opening bracket and function name\n      nested = 1;\n      j--;\n      while (j>=0 && nested>0) {\n        ch = st.charAt(j);\n        if (ch==\"(\") nested--;\n        else if (ch==\")\") nested++;\n        j--;\n      }\n      while (j>=0 && (ch=st.charAt(j))>=\"a\" && ch<=\"z\" || ch>=\"A\" && ch<=\"Z\")\n        j--;\n    } else if (ch>=\"a\" && ch<=\"z\" || ch>=\"A\" && ch<=\"Z\") {// look for variable\n      j--;\n      while (j>=0 && (ch=st.charAt(j))>=\"a\" && ch<=\"z\" || ch>=\"A\" && ch<=\"Z\")\n        j--;\n    } else { \n      return \"Error: incorrect syntax in \"+st+\" at position \"+j;\n    }\n    //find right argument\n    if (i==st.length-1) return \"Error: missing argument\";\n    k = i+1;\n    ch = st.charAt(k);\n    if (ch>=\"0\" && ch<=\"9\" || ch==\"-\") {// look for signed (decimal) number\n      k++;\n      while (k<st.length && (ch=st.charAt(k))>=\"0\" && ch<=\"9\") k++;\n      if (ch==\".\") {\n        k++;\n        while (k<st.length && (ch=st.charAt(k))>=\"0\" && ch<=\"9\") k++;\n      }\n    } else if (ch==\"(\") {// look for matching closing bracket and function name\n      nested = 1;\n      k++;\n      while (k<st.length && nested>0) {\n        ch = st.charAt(k);\n        if (ch==\"(\") nested++;\n        else if (ch==\")\") nested--;\n        k++;\n      }\n    } else if (ch>=\"a\" && ch<=\"z\" || ch>=\"A\" && ch<=\"Z\") {// look for variable\n      k++;\n      while (k<st.length && (ch=st.charAt(k))>=\"a\" && ch<=\"z\" ||\n               ch>=\"A\" && ch<=\"Z\") k++;\n    } else { \n      return \"Error: incorrect syntax in \"+st+\" at position \"+k;\n    }\n    st = st.slice(0,j+1)+\"Math.pow(\"+st.slice(j+1,i)+\",\"+st.slice(i+1,k)+\")\"+\n           st.slice(k);\n  }\n  while ((i=st.indexOf(\"!\"))!=-1) {\n    //find left argument\n    if (i==0) return \"Error: missing argument\";\n    j = i-1;\n    ch = st.charAt(j);\n    if (ch>=\"0\" && ch<=\"9\") {// look for (decimal) number\n      j--;\n      while (j>=0 && (ch=st.charAt(j))>=\"0\" && ch<=\"9\") j--;\n      if (ch==\".\") {\n        j--;\n        while (j>=0 && (ch=st.charAt(j))>=\"0\" && ch<=\"9\") j--;\n      }\n    } else if (ch==\")\") {// look for matching opening bracket and function name\n      nested = 1;\n      j--;\n      while (j>=0 && nested>0) {\n        ch = st.charAt(j);\n        if (ch==\"(\") nested--;\n        else if (ch==\")\") nested++;\n        j--;\n      }\n      while (j>=0 && (ch=st.charAt(j))>=\"a\" && ch<=\"z\" || ch>=\"A\" && ch<=\"Z\")\n        j--;\n    } else if (ch>=\"a\" && ch<=\"z\" || ch>=\"A\" && ch<=\"Z\") {// look for variable\n      j--;\n      while (j>=0 && (ch=st.charAt(j))>=\"a\" && ch<=\"z\" || ch>=\"A\" && ch<=\"Z\")\n        j--;\n    } else { \n      return \"Error: incorrect syntax in \"+st+\" at position \"+j;\n    }\n    st = st.slice(0,j+1)+\"factorial(\"+st.slice(j+1,i)+\")\"+st.slice(i+1);\n  }\n  return st;\n}\n\nfunction plot(fun,x_min,x_max,points,id,endpts) {\n  var pth = [];\n  var f = function(x) { return x }, g = fun;\n  var name = null;\n  if (typeof fun==\"string\") \n    eval(\"g = function(x){ with(Math) return \"+mathjs(fun)+\" }\");\n  else if (typeof fun==\"object\") {\n    eval(\"f = function(t){ with(Math) return \"+mathjs(fun[0])+\" }\");\n    eval(\"g = function(t){ with(Math) return \"+mathjs(fun[1])+\" }\");\n  }\n  if (typeof x_min==\"string\") { name = x_min; x_min = xmin }\n  else name = id;\n  var min = (x_min==null?xmin:x_min);\n  var max = (x_max==null?xmax:x_max);\n  var inc = max-min-0.000001*(max-min);\n  inc = (points==null?inc/200:inc/points);\n  var gt;\n//alert(typeof g(min))\n  for (var t = min; t <= max; t += inc) {\n    gt = g(t);\n    if (!(isNaN(gt)||Math.abs(gt)==\"Infinity\")) pth[pth.length] = [f(t), gt];\n  }\n  path(pth,name,null,endpts);\n  return pth;\n}\n\n// make polar plot\n\n// make Riemann sums\n\nfunction slopefield(fun,dx,dy) {\n  var g = fun;\n  if (typeof fun==\"string\") \n    eval(\"g = function(x,y){ with(Math) return \"+mathjs(fun)+\" }\");\n  var gxy,x,y,u,v,dz;\n  if (dx==null) dx=1;\n  if (dy==null) dy=1;\n  dz = Math.sqrt(dx*dx+dy*dy)/6;\n  var x_min = Math.ceil(xmin/dx);\n  var y_min = Math.ceil(ymin/dy);\n  for (x = x_min; x <= xmax; x += dx)\n    for (y = y_min; y <= ymax; y += dy) {\n      gxy = g(x,y);\n      if (!isNaN(gxy)) {\n        if (Math.abs(gxy)==\"Infinity\") {u = 0; v = dz;}\n        else {u = dz/Math.sqrt(1+gxy*gxy); v = gxy*u;}\n        line([x-u,y-v],[x+u,y+v]);\n      }\n    }\n}\n\n///////////////////////user graphics commands end here/////////////////////////\n\nfunction show_props(obj) {\n  var result = \"\";\n  for (var i=0; i< obj.childNodes.length; i++)\n    result += obj.childNodes.item(i) + \"\\n\";\n  return result;\n}\n\nfunction displayCoord(evt) {\n  if (showcoordinates) {\n    var svgroot = evt.target.parentNode;\n    var nl = svgroot.childNodes;\n    for (var i=0; i<nl.length && nl.item(i).nodeName!=\"text\"; i++);\n    var cnode = nl.item(i);\n    cnode.mtext = mtext;\n    cnode.mtext([svgroot.getAttribute(\"width\")-(-7),svgroot.getAttribute(\"height\")-7],\"(\"+getX(evt).toFixed(2)+\", \"+getY(evt).toFixed(2)+\")\", \"left\", \"\", \"11\");\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */  }\n}\n\nfunction removeCoord(evt) {\n    var svgroot = evt.target.parentNode;\n    var nl = svgroot.childNodes;\n    for (var i=0; i<nl.length && nl.item(i).nodeName!=\"text\"; i++);\n    var cnode = nl.item(i);\n    cnode.mtext = mtext;\n    cnode.mtext([svgroot.getAttribute(\"width\")-0,svgroot.getAttribute(\"height\")-0],\"\", \"aboveleft\", \"\");\n/* ASCIIMathML.js - copyright Peter Jipsen, released under the GPL\nSee http://www1.chapman.edu/~jipsen/mathml/asciimath.html/ */}\n\nfunction initASCIIMathCalculators(li) {\n  var i;\n  for (i=0; i<li.length; i++) {\n    li[i].innerHTML = calcstr;\n    AMprocessNode(li[i]);\n  }\n  li = document.getElementsByTagName(\"textarea\");\n  var st;\n  for (i=0; i<li.length; i++) {\n    st = li[i].getAttribute(\"onkeyup\");\n    if (st!=null) eval(String(st).replace(/function anonymous\\(\\)/,\"\"));\n  }\n}\n\nfunction calculate(inputId,outputId) {\n  var str = document.getElementById(inputId).value;\n  var err = \"\";\n  var ind = str.lastIndexOf(\"\\n\");\n  if (ind==str.length-1) str = str.slice(0,ind);\n  str = str.slice(str.lastIndexOf(\"\\n\")+1);\n  try {\n    var res = eval(mathjs(str));\n  } catch(e) {\n    err = \"syntax incomplete\";\n  }\n  if (!isNaN(res) && res!=\"Infinity\") \n    str = \"`\"+str+\" =` \"+(Math.abs(res-Math.round(res*1000000)/1000000)<1e-15?Math.round(res*1000000)/1000000:res)+err; \n  else if (str!=\"\") str = \"`\"+str+\"` = undefined\"; //debug:+mathjs(str);\n  var outnode = document.getElementById(outputId);\n  var n = outnode.childNodes.length;\n  for (var i=0; i<n; i++)\n    outnode.removeChild(outnode.firstChild);\n  outnode.appendChild(document.createTextNode(str));\n  AMprocessNode(outnode);\n}\n\nfunction append(st){\n  document.getElementById('in').value+=st;\n  calculate('in','out');\n  document.getElementById('in').scrollTop = 1000;\n  document.getElementById('in').focus();\n}\n\nfunction clearTextArea(){\n  document.getElementById('in').value=\"\";\n  calculate('in','out');\n  document.getElementById('in').focus();\n}\n\nvar calcstr = \"<table align=\\\"center\\\">\\n<tr><th>\\nASCIIMath Scientific Calculator\\n</th></tr>\\n<tr><td>\\nClick in the box to use your keyboard or use the buttons\\n</td></tr>\\n<tr><td>\\n<textarea id=\\\"in\\\" rows=\\\"3\\\" cols=\\\"40\\\" onkeyup=\\\"calculate('in','out')\\\"></textarea></td></tr>\\n<tr><td height=\\\"50\\\">Result: &nbsp; &nbsp; <span id=\\\"out\\\"></span></td></tr>\\n</table>\\n<table align=\\\"center\\\" cellspacing=\\\"0\\\" cellpadding=\\\"0\\\">\\n<tbody align=\\\"center\\\">\\n<tr>\\n<td colspan=\\\"4\\\">\\n<button onclick=\\\"append('sin^-1(')\\\"><font size=2>`sin^-1`</font></button><button onclick=\\\"append('cos^-1(')\\\"><font size=2>`cos^-1`</font></button><button onclick=\\\"append('tan^-1(')\\\"><font size=2>`tan^-1`</font></button></td>\\n<td><button onclick=\\\"clearTextArea()\\\">&nbsp;`C`&nbsp;</button></td>\\n\\n</tr>\\n<tr>\\n<td><button onclick=\\\"append('pi')\\\">&nbsp;`pi` &nbsp;</button></td>\\n<td><button onclick=\\\"append('sin(')\\\">&nbsp;`sin`</button></td>\\n<td><button onclick=\\\"append('cos(')\\\">&nbsp;`cos`</button></td>\\n<td><button onclick=\\\"append('tan(')\\\">&nbsp;`tan`</button></td>\\n<td><button onclick=\\\"append('^')\\\">`x^y`</button></td>\\n</tr>\\n<tr>\\n<td><button onclick=\\\"append('!')\\\">&nbsp; `!` &nbsp;</button></td>\\n\\n<td><button onclick=\\\"append('(')\\\"><font size=2>&nbsp;&nbsp;`(`&nbsp;&nbsp;</font></button></td>\\n<td><button onclick=\\\"append(')')\\\"><font size=2>&nbsp;&nbsp;`)`&nbsp;&nbsp;</font></button></td>\\n<td><button onclick=\\\"append('sqrt(')\\\"><font size=2>`sqrt({::}^\\ )`</font></button></td>\\n<td><button onclick=\\\"append('/')\\\">&nbsp;`-:\\ `</button></td>\\n</tr>\\n<tr>\\n<td><button onclick=\\\"append('log(')\\\">`log`</button></td>\\n<td><button onclick=\\\"append('7')\\\">&nbsp; `7` &nbsp;</button></td>\\n<td><button onclick=\\\"append('8')\\\">&nbsp; `8` &nbsp;</button></td>\\n\\n<td><button onclick=\\\"append('9')\\\">&nbsp; `9` &nbsp;</button></td>\\n<td><button onclick=\\\"append('*')\\\">&nbsp;`times`&nbsp;</button></td>\\n</tr>\\n<tr>\\n<td><button onclick=\\\"append('ln(')\\\">&nbsp;`ln`&nbsp;</button></td>\\n<td><button onclick=\\\"append('4')\\\">&nbsp; `4` &nbsp;</button></td>\\n<td><button onclick=\\\"append('5')\\\">&nbsp; `5` &nbsp;</button></td>\\n<td><button onclick=\\\"append('6')\\\">&nbsp; `6` &nbsp;</button></td>\\n\\n<td><button onclick=\\\"append('-')\\\">&nbsp;`-{::}`&nbsp;</button></td>\\n</tr>\\n<tr>\\n<td><button onclick=\\\"append('e')\\\">&nbsp; `e` &nbsp;</button></td>\\n<td><button onclick=\\\"append('1')\\\">&nbsp;&nbsp;`1` &nbsp;</button></td>\\n<td><button onclick=\\\"append('2')\\\">&nbsp; `2` &nbsp;</button></td>\\n<td><button onclick=\\\"append('3')\\\">&nbsp; `3` &nbsp;</button></td>\\n<td><button onclick=\\\"append('+')\\\">&nbsp;`+{::}`&nbsp;</button></td>\\n\\n</tr>\\n<tr>\\n<td> <!--button onclick=\\\"append('pi')\\\">&nbsp;`pi` &nbsp;</button--></td>\\n<td><button onclick=\\\"append('0')\\\">&nbsp; `0` &nbsp;</button></td>\\n<td><button onclick=\\\"append('.')\\\">&nbsp; `.` &nbsp;</button></td>\\n<td><button onclick=\\\"append('\\\\n')\\\">&nbsp;`\\\"ent\\\"`</button></td>\\n</tr>\\n</tbody>\\n</table>\";\n\n// GO1.1 Generic onload by Brothercake\n// http://www.brothercake.com/\n//onload function (replaces the onload=\"translate()\" in the <body> tag)\nfunction generic()\n{\n  if(!init()) return;\n  if (translateOnLoad) {\n    var nd = document.getElementById(\"processasciimathinmoodle\");\n    if (nd!=null) dsvglocation = nd.className;\n    if (nd!=null || !checkforprocessasciimathinmoodle) {\n      translate();\n      if (!noSVG && translateASCIIsvg) drawPictures();\n    }\n    var li = getElementsByClass(document,\"div\",\"ASCIIMathCalculator\");\n    if (!noMathML && li.length>0) initASCIIMathCalculators(li);\n  }\n};\n//setup onload function\nif(typeof window.addEventListener != 'undefined')\n{\n  //.. gecko, safari, konqueror and standard\n  window.addEventListener('load', generic, false);\n}\nelse if(typeof document.addEventListener != 'undefined')\n{\n  //.. opera 7\n  document.addEventListener('load', generic, false);\n}\nelse if(typeof window.attachEvent != 'undefined')\n{\n  //.. win/ie\n  window.attachEvent('onload', generic);\n}\n//** remove this condition to degrade older browsers\nelse\n{\n  //.. mac/ie5 and anything else that gets this far\n  //if there's an existing onload function\n  if(typeof window.onload == 'function')\n  {\n    //store it\n    var existing = onload;\n    //add new onload handler\n    window.onload = function()\n    {\n      //call existing onload function\n      existing();\n      //call generic onload function\n      generic();\n    };\n  }\n  else\n  {\n    //setup onload function\n    window.onload = generic;\n  }\n}\n</script>\n"

